#!/usr/bin/env python
import sys
import os
import dfont

txt = ""

cvt_dict = {
    "w_1337":           57,     #1337
    "w_1290":           127,    #1290
    "w_1231":           75,     #1231
    "w_1180":           73,     #1180
    "w_1133":           60,     #1133
    "w_1120":           200,    #1120
    "w_1112":           228,    #1112
    "w_1081":           71,     #1081
    "w_1051":           225,    #1051
    "w_1024":           138,    #1024
    "w_973":            178,    #973
    "w_926":            275,    #926
    "w_866":            286,    #866
    "w_569":            58,     #569
    "w_522":            108,    #522
    "w_455":            109,    #455
    "w_397":            45,     #397
    "w_385":            44,     #385
    "w_307":            1,      #307
    "w_291":            87,     #291
    "w_264":            271,    #264
#
    "w_236":            159,    #236
    "w_213":            102,    #213
    "w_195":            144,    #195
    "w_172":            16,     #172
    "w_154":            85,     #154
    "w_139":            238,    #139
#
    "base":             10,     #0
    "hstem":            13,         #358
    "hstem_curve":      144,        #195    =big curve hstem
    "hstem_thin":       54,         #246
#
    "vstem_236":        159,        #236    =3 spline, thinner
    "vstem_258":        161,        #258    =2 spline, thicker
    "vstem_thin":       85,         #154
    "vstem_small":      221,        #133 
    "vstem_tiny":       124,        #152
#
    "headstem":         30,         #127
    "headstem_plus_hole":   301,    #279
    "headstem_small":   36,         #113    =kho
    "headstem_small_plus_hole":   271,          #264
    "headstem_tiny":    158,        #106
    "headstem_tiny_plus_hole":    4,            #233
    "headstem_wan":     260,    #60
    "headstem_big":     16,     #172
    "headstem_sara":    59,     #88
    "headstem_sara_plus_hole":    94,    #193
    "sarastem":         30,         #127
#
    "headdia":          298,        #406
    "headdia_small":    198,        #377    =kho
    "headdia_tiny":     24,         #340
    "headdia_sara":     91,         #281
    "headhole":         131,        #152    
    "headneck_kho":     39,     #180    =kho
#
    "hwidth_a":         61,     #1085   =a
    "hwidth_ching":     275,    #926    =cho_ching
#
    "hnext_1":          58,         #569    =next spline of sho_sher
#
    "vheight":          179,        #1120   =normal height 
    "vheight_shoot":    202,        #1147   =overshoot height
    "vheight_hi":       49,     #1208   =ko 
    "vheight_hi_kho":   47,     #1204   =kho 
    "vheight_po":       163,        #1556   =po_pla, fo_fa
    "vheight_o":        197,        #1638   =sara_o, sara_i
    "vheight_lo":       152,        #29 
    "vheight_lu":       98,         #410    =lo_lu
    "vheight_below_do": 98,     #410
    "vheight_num":      275,        #926
    "vheight_sara1":    127,        #1290
#
    "head_diff":        131,    #254    =head of character: bo,po
    "beak_diff":        148,    #84     =beak of ko,tho
    "beak_diff_2":      38,     #340    =beak of ko,tho
#
    "front_001":        7,          #162
#
    "front_kai":        59,         #88     =front spacing of ko_kai
    "front_khai":       262,        #20     =front spacing of kho_khai
    "front_dek":        30,         #127
    "front_thahan":    38,         #37
#
    "front_khuad":      157,    #451    =front spacing of kho_khud
    "front_tahan":      38,     #340    =front spaceing of to_tahan
    "front_dek":        106,    #213    =front spaceing of do_dek
    "front_thong":      79,     #229    =front spaceing of to_thong
    "front_pung":       228,    #174    =front spaceing of po_pung
    "front_pan":        31,     #330    =front spacing of do_chada, po_pan
    "front_ma":         180,    #377    =front spaceing of mo_ma
    "front_ling":       1,      #184    =front spaceing of lo_ling, aw_ang
#
#special
    "special_1":        230,    #45
    "special_2":        88,     #20
#gap
    "gap_20":           262,    #20
    "gap_88":           59,     #88
    "gap_113":          36,     #113
    "gap_143":          129,    #143
    "gap_162":          7,      #162
    "gap_172":          16,     #172
    "gap_186":          41,     #186
    "gap_195":          144,    #195
    "gap_236":          159,    #236
}


def gedit(txt,pseudo=0):
    os.system('killall gedit')
    if pseudo:
        f = open('xcode.txt','w')
        f.write(txt)
        f.close()
        os.system('gedit xcode.txt &')
    f = open('x.txt','w')
    f.write('\n'.join(dfont.inst_encode(txt, cvt_dict )))
    f.close()
    os.system('gedit x.txt &')
    return

#----------------------------------------
def f_ip(li):
    if type(li) not in [ type([]),type(()) ]:
        raise "Error in f_ip, variable type must be list (or tuple)."

    if not li:
        return ""

    n = len(li)
    if n < 3:
        temp = '\n'.join( ["IP                %s" % (e,) for e in li] )
    else:
        t = "%s " * n
        temp = """
SLOOP               %s
IP                  %s
""" % tuple( [n,] + [t % tuple(li)] )
    return temp


#----------------------------------------
def ix():
    return """
IUP[x]
#
"""

def iy():
    return """
IUP[y]
#
"""

def sy():
    return """
#
SVTCA[y-axis]
"""


#------------------------------------------------
def h_reduce_head_1(s1):
    return """
f_deltap                %s 16-8  %s 30-8        #s1
""" % (s1,s1,)


def h_reduce_head_2(s1):
    return """
f_deltap                %s 16+8  %s 30+8        #s1
""" % (s1,s1,)


#------------------------------------------------
def dry_1(s):
    return """
SHPIX               -24 %s
""" % (s)

def dry_2(s):
    return """
SHPIX               24 %s
""" % (s)

#------------------------------------------------
def h_dry_head_1(s):
    return """
#
SHPIX               -24 %s
#SHPIX               -24 %s
""" % (s-2,s+2)

def h_dry_head_2(s):
    return """
##
SHPIX               24  %s
#SHPIX               24  %s
""" % (s-2,s+2)

def h_dry_head_12(s1,s2,s3):
    return """
#
SHPIX               24 %s
SHPIX               -24 %s
SHPIX               -24 %s
""" % (s1,s2,s3,)

def h_dry_head_21(s1,s2,s3):
    return """
#
SHPIX               24 %s
SHPIX               24 %s
SHPIX               -24 %s
""" % (s1,s2,s3,)

def h_dry_head_22(s1,s2,s3,s4):
    return """
#
SHPIX               24 %s
SHPIX               24 %s
SHPIX               -24 %s
SHPIX               -24 %s
""" % (s1,s2,s3,s4,)


#------------------------------------------------
def h_shift(s1, shift, sign=" "):
    return """
#
SHPIX                   %s%s    %s
""" % (sign,shift, s1)

def h_exp_head_1(s1):
    return h_shift(s1, 24, "-")

def h_exp_head_2(s1):
    return h_shift(s1, 24, " ")

def groove_1(s1):
    return h_shift(s1, 24, "-")

def groove_2(s1):
    return h_shift(s1, 24, " ")

def dx_1(s1):
    return h_shift(s1, 8, "-")

def dx_2(s1):
    return h_shift(s1, 8, " ")

#------------------------------------------------
def add_ip(s1,s2, li):
    if not type(li) in [type([]), type(())]:
        raise "add_ip error var-li must be list or tuple"

    n = len(li)
    i = '%s ' * n
    temp = """
SRP1                    %s              #s1
SRP2                    %s              #s2
SLOOP                   %s              #n
IP                      %s  #i
""" % (s1,s2,n,i,)
    return temp % tuple(li)


#------------------------------------------------
def hstem_1(s1,move_rp0=False):
    if move_rp0:
        return """
MIRP[rp0,min,rnd,grey]  hstem %s        #s1
""" % (s1,)
    else:
        return """
MIRP[min,rnd,grey]      hstem %s        #s1
""" % (s1,)

#....................
def hstem1(s1):
    return hstem_1(s1,move_rp0=False)

def hstem1m(s1):
    return hstem_1(s1,move_rp0=True)

#------------------------------------------------
def head_0(s2,add2, i121,i122, add3="",move_rp0=False):
    if move_rp0:
        temp = """
MDRP[rp0,rnd,grey]      %s              #s2     %s  #add2
""" % (s2,add2,)
    else:
        temp = """
MDRP[rnd,grey]          %s              #s2     %s  #add2
""" % (s2,add2,)
    temp += """
IP                      %s              #i121
IP                      %s              #i122   %s  #add3
""" % (i121,i122,add3,)
    return temp


#....................
def head0(s2, i121,i122):   #simple, no expand hole, no reduce head
    add2 = ""
    return head_0(s2,add2, i121,i122)


def head0s(s2,s2s, i121,i122, i12s1,i12s2):
    add2 = ""
    add3 = """
IP                      %s              #i12s1
IP                      %s              #i12s2
""" % (i12s1,i12s2,)
    return head_0(s2,add2, i121,i122, add3)


#..............................
def head01(s2, i121,i122, add2="", move_rp0=False):   #expand hole down
    add3 = """
%s                                      #h_exp_head_1(i122)
""" % (h_exp_head_1(i122),)
    return head_0(s2,add2, i121,i122, add3, move_rp0)

def head01m(s2, i121,i122, add2="", move_rp0=True):
    return head01(s2, i121,i122, add2, move_rp0)


def head011(s2, i121,i122, move_rp0=False):   #expand hole down, reduce head down
    add2 = """
f_deltap                 %s 16-8  %s 30-8       #s2
""" % (s2,s2,)
    return head01(s2, i121,i122, add2, move_rp0)

def head011m(s2, i121,i122, move_rp0=True):
    return head011(s2, i121,i122, move_rp0)

def head012(s2, i121,i122, move_rp0=False):   #expand hole down, reduce head down
    add2 = """
f_deltap                 %s 16+8  %s 30+8       #s2
""" % (s2,s2,)
    return head01(s2, i121,i122, add2, move_rp0)

def head012m(s2, i121,i122, move_rp0=True):
    return head012(s2, i121,i122, move_rp0)


#..............................
def head02(s2, i121,i122, add2="", move_rp0=False):   #expand hole down
    add3 = """
%s                                      #h_exp_head_2(i121)
""" % (h_exp_head_2(i121),)
    return head_0(s2,add2, i121,i122, add3, move_rp0)

def head02m(s2, i121,i122, move_rp0=True):
    move_rp0 = True
    return head02(s2, i121,i122, add2="", move_rp0=move_rp0)

#....................
def head11(s2, i121,i122, move_rp0=False):   #expand hole down, reduce head down
    add2 = """
f_deltap                 %s 11-8  %s 12-8       #s2
""" % (s2,s2,)
    return head01(s2, i121,i122, add2, move_rp0)


def head21(s2, i121,i122, move_rp0=False):   #expand hole down, reduce head up 
    add2 = """
f_deltap                 %s 11+8  %s 12+8       #s2
""" % (s2,s2,)
    return head01(s2, i121,i122, add2, move_rp0)



#..............................
def head12(s2, i121,i122, move_rp0=False):   #expand hole down, reduce head up 
    add2 = """
f_deltap                 %s 11-8  %s 12-8       #s2
""" % (s2,s2,)
    add3 = """
%s                                      #h_exp_head_2(i122)
""" % (h_exp_head_2(i122),)
    return head_0(s2,add2, i121,i122, add3, move_rp0)




def head2(s2, i121,i122):   #expand hole up, expand head
    add2 = """
f_deltap                %s 12+8         #s2
""" % (s2,)
    add3 = """
%s                                      #h_exp_head_2(i122)
""" (h_exp_head_1(i122),)
    return head_0(s2,add2, i121,i122, add3)


#------------------------------------------------
def vstem_c_1(s1,stem="vstem_236",sign="-"):
    return """
MIRP[grey]              %s %s           #stem,s1
SHPIX                   %s16 %s              #sign,s1
""" % (stem,s1,sign,s1,)

def vstem_c1(s1):
    return vstem_c_1(s1,sign="-")

def vstem_c1s(s1,s1s):
    return vstem_c1(s1) + """
SHP[rp2]                %s                  #s1s
""" % (s1s)

def vstem_c2(s1):
    return vstem_c_1(s1,sign=" ")

def vstem_c2s(s1,s1s):
    return vstem_c2(s1) + """
SHP[rp2]                %s                  #s1s
""" % (s1s)

#..............................
def vstem_1_1(s1,sign="-"):
    return """
MDRP[grey]              %s                   #s1
SHPIX                   %s16 %s              #sign,s1
""" % (s1,sign,s1,)

def vstem_11(s1):
    return vstem_1_1(s1,sign="-")

def vstem_12(s1):
    return vstem_1_1(s1,sign=" ")


#------------------------------------------------
def hf_0(s0,g1,s1,add1):    #ro-wo-aa
    return """
SRP0                    %s              #s0
MIRP[rp0,min,rnd,white] %s %s           #g1,s1      %s  #add1
""" % (s0,g1,s1,add1,)


#....................
def hf_wo_waen(s0,s1, g1="gap_88"):
    add1 =""
    return hf_0(s0,g1,s1,add1)


def hf_ro_rua(s0,s1,s2,g1="gap_88"):
    add1 = """
MDRP[grey]              %s              #s2
SHPIX                   -24 %s          #s2
""" % (s2,s2,)
    return hf_0(s0,g1,s1,add1)


#------------------------------------------------
def hfn_0(s1,s2,add1="", add2="",move_rp0=False):    #num
    if move_rp0:
        arg2 = "rp0,rnd,grey"
    else:
        arg2 = "min,rnd,grey"
    return """
MDAP[rnd]               %s              #s1         %s  #add1
MIRP[%s]                w_307 %s        #s2         %s  #add2
""" % (s1,add1,arg2,s2,add2)

def hfn0(s1,s2,add1="",move_rp0=False):
    return hfn_0(s1,s2,add1=add1,move_rp0=move_rp0)

#------------------------------------------------
def hfn_1(s0,g1,s1,add1, s2, add2):   #num
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      %s %s           #g1,s1      %s  #add1
MIRP[rnd,grey]          w_307 %s        #s2         %s  #add2
""" % (s0, g1,s1, add1, s2,add2,)


def hfn1(s0,s1,s2,g1="gap_113"):
    add1 = """
f_deltap                %s 10+8         #s1
""" % (s1,)
    add2 = ""
    return hfn_1(s0,g1,s1,add1, s2,add2)

def hrn1(s0,s1,s2,g1="gap_113"):
    add1 = """
f_deltap                %s 10-8         #s1
""" % (s1,)
    add2 = ""
    return hfn_1(s0,g1,s1,add1, s2,add2)


#------------------------------------------------
def hf_1(s0,g1,s1,add1, t1, s2, i121,i122, add2):   #ko-tho-lo
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      %s %s           #g1,s1          %s  #add1
MDRP[grey]              %s              #t1
MIRP[rnd,grey]          hstem   %s      #s2
IP                      %s              #i121
IP                      %s              #i122
%s                                      #h_exp_head_2(i121)
%s                                      #h_exp_head_1(i122) %s  #add2
""" % (s0, g1,s1, add1, t1, s2, i121,i122, h_exp_head_2(i121), h_exp_head_1(i122), add2)


#....................
def hf1_ko_kai(s0,s1, t1, s2, i121,i122, add2, g1="gap_186"):
    add1 = """
f_deltap                %s 15+8  %s 16+8
""" % (s1,s1,)
    return hf_1(s0,g1,s1,add1, t1, s2, i121,i122, add2)

def hf1_tho_thung(s0,s1, t1, s2, i121,i122, add2, s3, i131,i132):
    add1 = ""
    add2 = """
MDRP[rnd,grey]          %s              #s3
%s                                      #h_reduce_head(s3)
IP                      %s              #i131
IP                      %s              #i132
%s                                      #h_exp_head_1(i131)
""" % (s3, h_reduce_head_1(s3), i131,i132, h_exp_head_1(i131),) + add2
    return hf1_ko_kai(s0,s1, t1, s2, i121,i122, add2)

#....................
def hf_ko_kai(s0,s1, t1, s2, i121,i122):
    add2 = ""
    return  hf1_ko_kai(s0,s1, t1, s2, i121,i122, add2)


def hf_tho_thung(s0,s1, t1, s2, i121,i122, s3, i131,i132):
    add2 = ""
    return hf1_tho_thung(s0,s1, t1, s2, i121,i122, add2, s3, i131,i132)


#----------------------------------------
def hf_2(s0,g1,s1,add1,s2,add2, i121,i122):     #no_cho_bo
    add1 = """
f_deltap                %s 13-8         #s1
""" % (s1,) + add1

    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     %s %s           #g1,s1      %s  #add1
MDRP[rp0,rnd,grey]      %s              #s2
%s                                      #h_reduce_head_1(s2)
IP                      %s              #i121
IP                      %s              #i122       %s  #add2
%s                                      #h_exp_head_2(i122)
""" % (s0, g1,s1,add1, s2, h_reduce_head_1(s2), i121,i122, add2, h_exp_head_2(i122),)


#..............................
def hf2_1(s0,g1,s1,add1,s2,add2, i121,i122, s3):
    return hf_2(s0,g1,s1,add1,s2,add2, i121,i122) + """
MIRP[min,rnd,grey]      hstem %s        #s3
""" % (s3,)


def hf2_2(s0,g1,s1,add1,s2,add2, i121,i122, s3, add3):
    return hf_2(s0,g1,s1,add1,s2,add2, i121,i122) + """
MIRP[rp0,min,rnd,grey]  hstem %s    #s3         %s #add3
""" % (s3,add3,)


#..............................
def hf21_no_nu(s0,s1,add1, s2, s2s, i121,i122, s3): #hf2_1
    g1 = "gap_88"
    add2 = """
ALIGNRP                 %s              #s2s
""" % (s2s,)
    return hf2_1(s0,g1,s1,add1, s2,add2, i121,i122, s3)


#....................
def hf_tho_thahan(s0,s1, s2,s2s, i121,i122, s3):
    add1 = """
f_deltap                %s 11+8         #s1
""" % (s1,)
    return hf21_no_nu(s0,s1,add1, s2, s2s, i121,i122, s3)

def hf_no_nu(s0,s1, s2,s2s, i121,i122, s3):
    add1 = """
f_deltap                %s 12-8  %s 14-8    #s1
""" % (s1,s1,)
    return hf21_no_nu(s0,s1,add1, s2, s2s, i121,i122, s3)

def hf_pho_phan(s0,s1, s2,s2s, i121,i122, s3):
    add1 = """
f_deltap                %s 14-8    #s1
""" % (s1,)
    return hf21_no_nu(s0,s1,add1, s2, s2s, i121,i122, s3)


def hf_cho_ching(s0,s1,t1, s2,s2s, i121,i122, s3):  #hf2_1
    add1 = """
MDRP[rnd,grey]          %s              #t1
""" % (t1,)
    return hf21_no_nu(s0,s1,add1, s2,s2s, i121,i122, s3)


def hf_bo_baimai(s0,s1, s2, i121,i122, s3, s4):     #hf2_2
    g1 = "gap_88"
    add1 = """
f_deltap                %s 14-8         #s1
""" % (s1,)
    add2 = ""
    add3 = """
MDRP[rnd,grey]          %s              #s4
""" % (s4,)
    return hf2_2(s0,g1,s1,add1, s2,add2, i121,i122, s3, add3)


def hf_so_rusi(s0,s1, s2, i121,i122, s3, s4, s5, s6, i561,i562):     #hf2_2
    g1 = "gap_88"
    add1 = """
f_deltap                %s 11+8         #s1
""" % (s1,)
    add2 = ""
    add3 = """
MDRP[rnd,grey]          %s              #s4
SRP0                    %s              #s2
MDRP[rp0,rnd,grey]      %s              #s5
MDRP[grey]              %s              #s6
IP                      %s              #i561
IP                      %s              #i562
""" % (s4,s2,s5,s6, i561,i562)
    return hf2_2(s0,g1,s1,add1, s2,add2, i121,i122, s3, add3)


#------------------------------------------------
def hf_3(s0, s1,add1, s2,add2, i121,i122,i123, g1="gap_88"):     #kho_khai,kho_khuat
    return """
SRP0                    %s                  #s0
MIRP[rp0,rnd,grey]      %s %s               #g1,s1     %s  #add1
MDRP[rp0,rnd,grey]      %s                  #s2     %s  #add2
IP                      %s                  #i121-123
IP                      %s
IP                      %s
""" % (s0, g1,s1,add1, s2,add2, i121,i122,i123,)


#,,,,,,,,,,,,,,,,,,,,
def hf_kho_khai(s0,s1,s2, i121,i122,i123):
    add1 = """
f_deltap                %s 12-8  %s 13-4  %s 14-8  %s 17-8  %s 35-8    #s1
""" % tuple((s1,)*5)
    add2 = ""
    return hf_3(s0, s1,add1, s2,add2, i121,i122,i123)


def hf_cho_chang(s0,s1,s2, i121,i122,i123):
    add1 = """
f_deltap                %s 12-8  %s 13-4  %s 14-8  %s 35-8  %s 36-8 %s 37-8  %s 38-8  %s 39-8  %s 40-8      #s1
""" % tuple((s1,)*9)
    add2 = ""
    return hf_3(s0, s1,add1, s2,add2, i121,i122,i123)


def hf_kho_khuat(s0,s1,s2, i121,i122,i123, g1="gap_88"):
    add1 = """
f_deltap                %s 12-8  %s 13-8    #s1
""" % tuple((s1,)*2)
    add2 =  ""
    return hf_3(s0, s1,add1, s2,add2, i121,i122,i123, g1)


def hf_maiyamok(s0,s1,s2, i121,i122,i123, g1="gap_113"):
    add1 = ""
    add2 =  ""
    return hf_3(s0, s1,add1, s2,add2, i121,i122,i123, g1)


#------------------------------------------------
def hf_4(s0,s1,add1, s2,add2, i121,i122,i123,i124,i125, s3): #pho_samphao
    return """
SRP0                    %s                  #s0
MIRP[rp0,rnd,white]     gap_113 %s          #s1
f_deltap                %s 10+8             #s1     %s  #add1
MDRP[rp0,rnd,grey]      %s                  #s2
%s                                          #h_reduce_head_1(s2)    %s  #add2
IP                      %s                  #i121
IP                      %s                  #i122
IP                      %s                  #i123
IP                      %s                  #i124
IP                      %s                  #i125
MIRP[rp0,rnd,grey]      hstem %s            #s3
%s                                          #h_exp_head_2(i122)
%s                                          #h_exp_head_1(i123)
%s                                          #h_exp_head_2(i125)
""" % (s0,s1,s1,add1, s2,h_reduce_head_1(s2), add2, i121,i122,i123,i124,i125, s3, h_exp_head_2(i122),h_exp_head_1(i123),h_exp_head_2(i125),)


#....................
def hf_pho_samphao(s0,s1, s2, i121,i122,i123,i124,i125, s3):
    add1 = ""
    add2 = ""
    return hf_4(s0,s1,add1, s2,add2, i121,i122,i123,i124,i125, s3)

#----------------------------------------
def hf_5(s0,s1,add1, s2,s3, i231,i232,i233):    #cho_chan
    return """
SRP0                    %s              #s0=    44
MIRP[rp0,rnd,grey]      gap_88 %s       #s1=    22  %s  #add1
MDRP[rp0,rnd,grey]      %s              #s2=    7
MDRP[rnd,grey]          %s              #s3=    12
IP                      %s              #i231=  41
IP                      %s              #i232=  35
IP                      %s              #i233=  2
%s                                      #h_exp_head_2(i232)
""" % (s0,s1,add1, s2,s3, i231,i232,i233, h_exp_head_2(i232),)

#....................
def hf_cho_chan(s0,s1, s2,s3, i231,i232,i233):
    add1 = ""
    return hf_5(s0,s1,add1, s2,s3, i231,i232,i233)


def hf_tho_than(s0,s1,t1, s2,s3, i231,i232,i233):
    add1 = """
MDRP[grey]          %s              #t1
""" % (t1,)
    return hf_5(s0,s1,add1, s2,s3, i231,i232,i233)


#----------------------------------------
def hf_6(s0,s1,add1, s2,add2, s3,add3, i131,i132, g1="gap_143"):  #pho_phung
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      %s %s           #g1,s1  %s  #add1
MIRP[min,rnd,grey]      hstem %s        #s2     %s  #add2
MDRP[rnd,grey]          %s              #s3
%s                                      #h_reduce_head_1(s3)  %s  #add3
IP                      %s              #i131
IP                      %s              #i132
%s                                      #h_exp_head_1(i131)
""" % (s0, g1,s1,add1, s2,add2, s3,h_reduce_head_1(s3),add3, i131,i132, h_exp_head_1(i131),)


#....................
def hf_lo_ling(s0,s1, s2, t2, s3, i131,i132, g1="gap_113",add1=""):
    add3 = ""
    add2 = """
MDRP[rnd,grey]          %s              #t2
""" % (t2,)
    return hf_6(s0,s1,add1, s2,add2, s3,add3, i131,i132, g1)

def hf_o_ang(s0,s1, s2, t2, s3, i131,i132, g1="gap_143"):
    add1 = """
f_deltap                %s 9-8          #s1
""" % (s1,)
    return hf_lo_ling(s0,s1, s2, t2, s3, i131,i132, g1,add1)

def hf_ho_nokhuk(s0,s1, s2, t2,t3, s3, i131,i132, g1="gap_113",add1=""):
    add3 = ""
    add2 = """
MDRP[rp0,rnd,grey]      %s              #t2
MIRP[min,rnd,grey]      vstem_236 %s    #t3
SRP0                    %s              #s1
""" % (t2,t3,s1,)
    return hf_6(s0,s1,add1, s2,add2, s3,add3, i131,i132, g1)


#....................
def hf_pho_phung(s0,s1, s2,s2s, s3, i131,i132):
    add1 = add3 = ""
    add2 = """
SHP[rp2]                %s              #s2s
""" % (s2s,)
    return hf_6(s0,s1,add1, s2,add2, s3,add3, i131,i132)


#----------------------------------------
def hf_7(s0,g1,s1,add1, s2,add2, s2s, i121,i122, s3, s4,add4, i241,i242):  #mo_ma
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     %s %s           #g1,s1      %s  #add1
MDRP[rp0,rnd,grey]      %s              #s2         %s  #add2
ALIGNRP                 %s              #s2s
IP                      %s              #i121
IP                      %s              #i122
%s                                      #h_exp_head_2(i122)
MIRP[min,rnd,grey]      hstem %s        #s3
MDRP[rnd,grey]          %s              #s4
%s                                      #h_reduce_head_2(s4)
IP                      %s              #i241
IP                      %s              #i242       %s  #add4
%s                                      #h_exp_head_2(i242)
""" % (s0,g1,s1,add1, s2,add2, s2s, i121,i122, h_exp_head_2(i122), s3, s4, h_reduce_head_2(s4), i241,i242, add4, h_exp_head_2(i242), )


#....................
def hf_mo_ma(s0,s1, s2, s2s, i121,i122, s3, s4, i241,i242):
    g1 = "gap_113"
    add1 = """
f_deltap                %s 13-8  %s 32-8  %s 33-8
""" % tuple((s1,)*3)
    add2 = """
f_deltap                %s 12-8  %s 16-8  %s 19-8  %s 22-8  
""" % tuple((s2,)*4)
    add4 = ""
    return hf_7(s0,g1,s1,add1, s2,add2, s2s, i121,i122, s3, s4,add4, i241,i242)


#----------------------------------------
def hf_8(s0,g1, s1,add1, s2,i121, s3,add3, s3s, i131,i132, s4,add4, s5):     #yo_yak
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      %s %s           #g1,s1      %s  #add1
MIRP[min,rnd,grey]      hstem %s        #s2
IP                      %s              #i121
SHPIX                   24 %s           #i121
MDRP[rnd,grey]          %s              #s3         %s  #add3
SHP[rp2]                %s              #s3s
IP                      %s              #i131
IP                      %s              #i132
%s                                      #h_exp_head_1(i131)
MDRP[rp0,rnd,grey]      %s              #s4         %s  #add4
MIRP[min,rnd,grey]      hstem %s        #s5
SHPIX                   -24 %s          #s5
""" % (s0, g1,s1, add1, s2,i121, i121, s3,add3, s3s, i131,i132, h_exp_head_1(i131), s4,add4, s5,s5, )


#....................
def hf_yo_yak(s0, s1,s2, i121, s3,s3s, i131,i132, s4,s5):
    g1 = "gap_162"
    add1 = """
f_deltap                %s 9-8
""" % tuple((s1,)*1)
    add3 = ""
    add4 = ""
    return hf_8(s0,g1, s1,add1, s2,i121, s3,add3, s3s, i131,i132, s4,add4, s5)


#------------------------------------------------
def hr_1(s0,g1,s1,add1, s2,add2=""):    #base of ko_kai
    return """
SRP0                    %s                  #s0
MIRP[rp0,rnd,white]     %s %s               #g1,s1      %s  #add1
MIRP[min,rnd,grey]      hstem %s            #s2         %s  #add2
""" % (s0, g1, s1,add1, s2,add2)

def hr10(s0,s1,s2,g1="gap_162"):
    return hr_1(s0,g1,s1,"",s2,"")

    
#....................
def hr_ho_nokhuk(s0, s1, s2, i121,i122,i123,i124):
    g1 = "gap_186"
    add1 = """
f_deltap        %s 17+8  %s 20+8
""" % tuple((s1,)*2)
    add2 = """
SLOOP                   4
IP                      %s %s %s %s 
""" % (i121,i122,i123,i124,)
    return hr_1(s0,g1,s1,add1, s2,add2)

#..............................
def hr_162(s0,s1,add1, s2,add2, g1="gap_162"):
    return hr_1(s0,g1,s1,add1, s2,add2)


def hrs_162(s0,s1,add1, s2,s2s, add2="", g1="gap_162"):
    add2 = """
SHP[rp2]                %s                  #s2s
""" % (s2s,) + add2
    return hr_1(s0,g1,s1,add1,s2,add2)


#..............................
def hr1_wo_wan(s0,s1,add1, s2,add2, s3, i131,i132):
    add2 = add2 + """
MDRP[rnd,grey]          %s                  #s3
IP                      %s                  #i131
IP                      %s                  #i132
""" % (s3, i131,i132,)
    return hr_162(s0,s1,add1, s2,add2)


#....................
def hr_wo_wan(s0,s1,s2,s3, i131,i132):
    add1 = add2 = ""
    return hr1_wo_wan(s0,s1,add1, s2,add2, s3, i131,i132)


def hr_ro_rua(s0,s1,s2,s3, i131,i132, t1):
    add1 = ""
    add2 = """
MDRP[grey]              %s                  #t1
""" % (t1,)
    return hr1_wo_wan(s0,s1,add1, s2,add2, s3, i131,i132)


#....................
def hr_ko_kai(s0,s1, s2):
    add1 = ""
    add2 = ""
    return hr_162(s0,s1,add1, s2,add2)

def hr_o_ang(s0,s1, s2):
    add1 = """
f_deltap                %s 20+8  %s 23+8  #s1
""" % tuple((s1,)*2)
    add2 = ""
    return hr_162(s0,s1,add1, s2,add2)


#..............................
def hr1_kho_khai(s0,s1,add1, s2,add2, s3,add3, s4,add4, s5,add5, s6,add6):
    add2 = add2 + """
MDRP[rp0,rnd,grey]      %s                  #s3     %s  #add3
MIRP[min,rnd,grey]      hstem %s            #s4     %s  #add4
SRP0                    %s                  #s2
MDRP[rp0,min,rnd,grey]  %s                  #s5     %s  #add5
MIRP[grey]              w_236 %s            #s6     %s  #add6
""" % (s3,add3, s4,add4, s2, s5,add5, s6,add6)
    return hr_162(s0,s1,add1, s2,add2)


#....................
def hr_tho_nangmontho(s0, s1,s2, s3,s3s, s4, s5, i251,i252,i253,i254, s6):
    add1 = """
f_deltap                %s 20+8  %s 21+8  %s 22+8  
""" % tuple((s1,)*3)
    add2 = add4 = add6 = ""
    add3 = """
ALIGNRP                 %s                  #s3s
""" % (s3s,)
    add5 = """
SLOOP                   4
IP                      %s %s %s %s         #i251-254
""" % (i251,i252,i253,i254)
    return hr1_kho_khai(s0,s1,add1, s2,add2, s3,add3, s4,add4, s5,add5, s6,add6)


#....................
def hr_kho_khai(s0,s1, s2, s3,s4,s5,s6):
    add1 = """
f_deltap                %s 19+8  %s 20+8  %s 21+8  %s 26+8  %s 32+8  
""" % tuple((s1,)*5)
    add2 = ""
    add3 = """
f_deltap                %s 9-8
""" % (s3,)
    add4 = ""
    add5 = """
f_deltap                %s 9+6  %s 20+1  %s 45+8
""" % tuple((s5,)*3)
    add6 = """
f_deltap                %s 9+4  %s 20+2  %s 22+1  %s 23+3  %s 24+4  
SHPIX                   16 %s
""" % tuple((s6,)*6)
    return hr1_kho_khai(s0,s1,add1, s2,add2, s3,add3, s4,add4, s5,add5, s6,add6)


def hr_kho_khuat(s0, s1,s2, s3,s4, s5,s6):
    add1 = """
f_deltap                %s 19+8  %s 20+8  %s 21+8
""" % tuple((s1,)*3)
    add2 = add3 = add4 = add5 = add6 = ""
    return hr1_kho_khai(s0,s1,add1, s2,add2, s3,add3, s4,add4, s5,add5, s6,add6)


def hr_kho_rakhang(s0, s1,s2,s2s, s3,s3s, s4, t41, i441,i442, s5,s6):
    add1 = """
f_deltap                %s 20+8  %s 21+8  %s 22+8
""" % tuple((s1,)*3)
    add2 = """
SHP[rp2]                %s                  #s2s
""" % (s3s,)
    add3 = """
f_deltap                %s 9-8  %s 35+8  
""" % tuple((s3,)*2)
    add4 = """
ALIGNRP                 %s                  #s3s
MDRP[rnd,grey]          %s                  #t41
f_deltap                %s 12+8  %s 25+8
IP                      %s                  #i441
IP                      %s                  #i442
f_deltap                %s 20+3  %s 26+3    #s4
""" % (s3s, t41, t41,t41, i441,i442, s4,s4,)
    add5 = """
f_deltap                %s 9+4
""" % tuple((s5,)*1)
    add6 = ""
    return hr1_kho_khai(s0,s1,add1, s2,add2, s3,add3, s4,add4, s5,add5, s6,add6)


#..............................
def hr1_cho_chang(s0,s1,add1, s2, i12, s3,add3, s4, s5,s6, i25, s7,s8):
    add2 = """
IP                      %s                  #i12
""" % (i12,)
    add4 = ""
    add5 = """
IP                      %s                  #i25
""" % (i12,)
    add6 = """
SRP0                    %s                  #s1
MDRP[rp0,rnd,grey]      %s                  #s7
MIRP[min,rnd,grey]      hstem %s            #s8
""" % (s1,s7,s8,)
    return hr1_kho_khai(s0,s1,add1, s2,add2, s3,add3, s4,add4, s5,add5, s6,add6)

#....................
def hr_cho_chang(s0,s1, s2, i12, s3,s4, s5,s6, i25, s7,s8):
    add1 = """
f_deltap                %s 19+8  %s 20+8  %s 21+8  %s 22+8  %s 24+8  
""" % tuple((s1,)*5)
    add3 = """
f_deltap                %s 9-8
""" % (s3,)
    return hr1_cho_chang(s0,s1,add1, s2, i12, s3,add3, s4, s5,s6, i25, s7,s8)

def hr_so_so(s0,s1, s2, i12, s3,s4, s5,s6, i25, s7,s8):
    add1 = """
f_deltap                %s 19+8  %s 20+8  %s 21+8  %s 32+8  %s 33+8
""" % tuple((s1,)*5)
    add3 = ""
    return hr1_cho_chang(s0,s1,add1, s2, i12, s3,add3, s4, s5,s6, i25, s7,s8)


#....................
def hr_kho_khwai(s0,s1,s2):
    add1 = """
f_deltap            %s 20+8  %s 21+8  %s 28+8  %s 32+8  %s 33+8  %s 49+8
""" % tuple((s1,)*6)
    add2 = ""
    return hr_162(s0,s1,add1, s2,add2)


def hr_ngo_ngu(s0,s1,s2, s3, i131,i132):
    add1 = ""
    add2 = """
MDRP[rnd,grey]          %s                  #s3
%s                                          #h_reduce_head_2(s3)
IP                      %s                  #i131
IP                      %s                  #i132
%s                                          #h_exp_head_2(i132)
""" % (s3, h_reduce_head_2(s3), i131,i132, h_exp_head_2(i132))
    return hr_162(s0,s1,add1, s2,add2)


def hr_mo_ma(s0,s1,s2,s2s):
    add1 = ""
    add2 = ""
    return hrs_162(s0,s1,add1, s2,s2s,add2)


def hr_pho_phan(s0,s1,s2,s2s):
    add1 = """
f_deltap    %s 19+8  %s 20+8  
""" % (s1,s1, )
    add2 = ""
    return hrs_162(s0,s1,add1, s2,s2s,add2)


def hr_lo_chula(s0,s1,s2,s2s, t3, s3, i131,i132,i133):
    g1 = "gap_195"
    add1 = """
f_deltap    %s 14-8  %s 17+8  
""" % (s1,s1, )
    add2 = """
MDRP[min,rnd,grey]          %s              #t3
MDRP[rnd,grey]              %s              #s3
SLOOP                       3
IP                          %s %s %s        #i131-133
%s                                          #h_exp_head_2(i132)
""" % (t3,s3,i131,i132,i133,h_exp_head_2(i132))
    return hrs_162(s0,s1,add1, s2,s2s,add2, g1)


def hr_yo_ying(s0,s1, s2, s3, s4):
    add1 = ""
    add2 = """
MDRP[rp0,rnd,grey]          %s              #s3
MIRP[min,rnd,grey]          hstem %s        #s4
""" % (s3,s4,)
    return  hr_162(s0,s1,add1, s2,add2)


def hr_do_chada(s0,s1,s2,s2s, s3, s4, i241,i242,i243,i244):
    add1 = ""
    add2 = """
MDRP[rp0,rnd,grey]          %s              #s3
MDRP[min,rnd,grey]          %s              #s4
SRP1                        %s              #s4
SRP1                        %s              #s2
SLOOP                       4
IP                          %s %s %s %s     #i241-244
%s                                          #h_exp_head_2(65)
%s                                          #h_exp_head_1(16)
""" % (s3, s4, s4,s2, i241,i242,i243,i244, h_exp_head_2(i241),h_exp_head_1(i244),)
    return hrs_162(s0,s1,add1, s2,s2s,add2)

def hr_to_patak(s0,s1,s2, s3, s4, i241,i242,i243,i244,i245,i246):
    add1 = ""
    add2 = """
MDRP[rp0,rnd,grey]          %s              #s3
MDRP[min,rnd,grey]          %s              #s4
SRP1                        %s              #s4
SRP1                        %s              #s2
SLOOP                       6
IP                          %s %s %s %s %s %s     #i241-246
%s                                          #h_exp_head_2(i241)
%s                                          #h_exp_head_1(i244)
""" % (s3, s4, s4,s2, i241,i242,i243,i244,i245,i246, h_exp_head_2(i241),h_exp_head_1(i244),)
    return hr_162(s0,s1,add1, s2,add2)


def hr_bo_baimai(s0,s1,s2):
    add1 = """
f_deltap    %s 20+8  
""" % (s1, )
    add2 = ""
    return hr_162(s0,s1,add1, s2,add2)

def hr_so_rusi(s0,s1,s1s,t1, s2,s2s):
    add1 = """
f_deltap    %s 15-8  %s 17+8  %s 26-8  
ALIGNRP             %s                  #s1s
MDRP[min,rnd,grey]  %s                  #t1
""" % tuple((s1,)*3 + (s1s,t1,))
    add2 = """
SHP[rp2]            %s                  #s2s
""" % (s2s,)
    return hr_162(s0,s1,add1, s2,add2, g1="gap_195")


def hr_yo_yak(s0,s1,s2):
    add1 = """
f_deltap    %s 19+8  %s 20+8  
""" % (s1,s1, )
    add2 = ""
    return hr_162(s0,s1,add1, s2,add2)


def hr_tho_thahan(s0,s1,s2):
    add1 = """
f_deltap    %s 20+8  %s 21+8
""" % (s1,s1, )
    add2 = ""
    return hr_162(s0,s1,add1, s2,add2)


def hr_ho_hip(s0,s1,s2, s3,s4, i341,i342,i343,i344):
    add1 = """
f_deltap    %s 20+8  %s 21+8
""" % (s1,s1, )
    add2 = """
MDRP[rp0,rnd,grey]      %s              #s3
MDRP[rnd,grey]          %s              #s4
f_deltap                %s 16+8  %s 20-8         #s4
SLOOP                   4
IP                      %s %s %s %s     #i341-344
""" % (s3,s4, s4,s4, i341,i342,i343,i344,)
    return hr_162(s0,s1,add1, s2,add2)


#------------------------------------------------
def hr_2(s0,g1,s1,add1,s2,add2, i121,i122, s3,add3, s4):    #no_nu
    return """
SRP0                %s              #s0
MIRP[rp0,rnd,white] %s %s           #g1,s1  %s  #add1
MDRP[rnd,grey]      %s              #s2     %s  #add2
IP                  %s              #i121
IP                  %s              #i122
%s                                  #h_exp_head_1(i121)
MDRP[rp0,rnd,grey]  %s              #s3     %s  #add3
MIRP[min,rnd,grey]  hstem %s        #s4
""" % (s0,g1,s1,add1, s2,add2, i121,i122, h_exp_head_1(i121), s3,add3, s4)


#....................
def hr_no_nu(s0,s1,s2,i121,i122,s3,s4):
    g1 = "gap_88"
    add1 = """
f_deltap            %s 11-8  %s 14+8    #s1
""" % (s1,s1,)
    add2 = ""
    add3 = ""
    return hr_2(s0,g1,s1,add1,s2,add2, i121,i122, s3,add3, s4)

#----------------------------------------
def hr_3(s0,g1,s1,add1, s2,s3,s4,i341):     #cho_chan
    return """
SRP0                %s              #s0  
MIRP[rp0,rnd,grey]  %s %s           #g1,s1  %s  #add1
MIRP[min,rnd,grey]  hstem %s        #s2  
MDRP[rp0,rnd,grey]  %s              #s3  
MIRP[min,rnd,grey]  hstem %s        #s4  
IP                  %s              #i341
""" % (s0, g1,s1,add1, s2,s3,s4, i341)

#....................
def hr_cho_chan(s0,s1,s2,s3,s4,i341):
    g1 = "gap_143"
    add1 = ""
    return hr_3(s0,g1,s1,add1, s2,s3,s4,i341)


def hr_tho_than(s0,s1,t1,s2,s3,s4,i341):
    g1 = "gap_172"
    add1 = """
MDRP[grey]          %s              #t1
""" % (t1,)
    return hr_3(s0,g1,s1,add1, s2,s3,s4,i341)


#----------------------------------------
def hr_4(s1,s2, i121,i122,add2=""):     #sara i
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #s2
IP                      %s              #i121
IP                      %s              #i122   %s  #add2
SHPIX                   -24 %s          #i121
SHPIX                    24 %s          #i122
""" % (s1,s2,i121,i122,add2, i121,i122,)


#....................
def hr_sara_i(s1,s2,i121,i122):
    return hr_4(s1,s2, i121,i122)


def hr_sara_ii(s1,s2,i121,i122, s3):
    add2 = """
MDRP[min,rnd,grey]      %s              #s3
SHPIX                   -8 %s           #s1
SHPIX                   8 %s            #s3
""" % (s3,s1,s3,)
    return hr_4(s1,s2, i121,i122, add2)


def hr_sara_ue(s1,s2,i121,i122, s3,s4, i341,i342):
    add2 = """
MDRP[rp0,min,rnd,grey]  %s              #s3
MDRP[rnd,grey]          %s              #s4
f_deltap                %s 12-8  %s 13-8  %s 14-8  %s 15-8
IP                      %s              #i341
IP                      %s              #i342
""" % (s3,s4, s4,s4,s4,s4, i341,i342,)
    return hr_4(s1,s2, i121,i122, add2)


def hr_sara_uee(s1,s2,i121,i122, s3,s4,s5):
    add2 = """
MDRP[rp0,min,rnd,grey]  %s              #s3
MDRP[rp0,min,rnd,grey]  %s              #s4
MDRP[min,rnd,grey]      %s              #s5
SHPIX                   -8 %s           #s1
SHPIX                   8 %s            #s3
SHPIX                   -8 %s           #s4
SHPIX                   8 %s            #s5
""" % (s3,s4,s5,s1,s3,s4,s5,)
    return hr_4(s1,s2, i121,i122, add2)


#------------------------------------------------
def hr_5(s0,s1,s2, i121,i122, s3, add3=""): #sara e
    return """
SRP0                        %s              #s0
MIRP[rp0,rnd,grey]          gap_88 %s       #s1
f_deltap                    %s 11-8  %s 13+8    #s1
%s                                      #head012m(s2,i121,i122)
%s                                      #hstem1(s3) %s  #add3
""" % (s0,s1,s1,s1, head012m(s2,i121,i122), hstem1(s3), add3)

#....................
def hr_sara_e(s0,s1,s2, i121,i122, s3): #sara e
    return hr_5(s0,s1,s2, i121,i122, s3)


#------------------------------------------------
#....................
def hr_sara_u(s1,s2,s3, i131,i132):
    return """
MDAP[rnd]                   %s              #s1
MDRP[min,rnd,grey]          %s              #s2
MDRP[rnd,grey]              %s              #s3
IP                          %s              #i131
IP                          %s              #i132
%s                                      #h_exp_head_2(i132)
SHPIX                       -8 %s           #s1
""" % (s1,s2,s3, i131,i132, h_exp_head_2(i132), s1,)

def hr_sara_uu(s1,s2,s3,s4,s5, i351,i352):
    return """
MDAP[rnd]                   %s              #s1
MDRP[rp0,min,rnd,grey]      %s              #s2
MDRP[rp0,min,rnd,grey]      %s              #s3
MDRP[min,rnd,grey]          %s              #s4
MDRP[rnd,grey]              %s              #s5
IP                          %s              #i351
IP                          %s              #i352
%s                                      #h_exp_head_2(i352)
SHPIX                       -8 %s           #s1
SHPIX                        8 %s           #s2
""" % (s1,s2,s3, s4,s5, i351,i352, h_exp_head_2(i352), s1,s2,)


#------------------------------------------------
def vb_bust_kho(s1,s2,i1,i2):
    return """
SRP1                %s
SRP2                %s
IP                  %s
IP                  %s
""" % (s1,s2,i1,i2,)


#------------------------------------------------
def hx_notch_ko(s1,s2):
    return """
#
SHPIX               -16     %s
SHPIX               16      %s
""" % (s1, s2,)


def sx_notch_1(s1):
    return """
#
SHPIX               -16     %s
""" % (s1,)

def sx_notch_2(s1):
    return """
#
SHPIX                16     %s
""" % (s1,)

#----------------------------------------
def v0(s0):
    return  """
MDAP[rnd]               %s              #s0
""" % (s0,)


def vs0(s0,s0s):
    return """
MDAP[rnd]               %s              #s0
ALIGNRP                 %s              #s0s
""" % (s0, s0s,)


#------------------------------------------------
def vsb0(s0,s0s, s1):
    return """
MDAP[rnd]               %s              #s0
ALIGNRP                 %s              #s0s
%s                                  #vstem_c1(s1)
""" % (s0,s0s, vstem_c1(s1), )

def vsb0s(s0,s0s, s1,s1s):
    return vsb0(s0,s0s, s1) + """
SHP[rp2]                %s              #s1s
""" % (s1s,)


#------------------------------------------------

def vb_0(s0,add0, s1,add1, stem='vstem_236'):
    return """
MDAP[rnd]               %s              #s0     %s #add0
%s                                  #vstem_c1(s1)   %s  #add1
""" % (s0,add0, vstem_c1(s1),add1)

def vb0(s0,s1):
    add0 = add1 = ""
    return vb_0(s0,add0, s1,add1)

def vb0s(s0,s1,s1s):
    add0 = ""
    add1 = """
SHP[rp2]                %s              #s1s
""" % (s1s,)
    return vb_0(s0,add0, s1,add1)

#....................
def vb1(s0,s1):
    add0 = ""
    add1 = ""
    return vb_0(s0,add0, s1,add1, stem='vstem_258')

def vb1s(s0,s1,s1s):
    add0 = ""
    add1 = """
SHP[rp2]                %s              #s1s
""" % (s1s,)
    return vb_0(s0,add0, s1,add1, stem='vstem_258')

def vbs1s(s0,s0s, s1,s1s):
    add0 = """
ALIGNRP                 %s              #s0s
""" % (s0s,)
    add1 = """
SHP[rp2]                %s              #s1s
""" % (s1s,)
    return vb_0(s0,add0, s1,add1, stem='vstem_258')

#....................
def vb0_low_head(s0,s1,add1,s2,add2):
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      vheight_lo %s   #s1         %s  #add1
MDRP[rnd,grey]          %s              #s2         %s  #add2
""" % (s0,s1,add1, s2, add2)


def vb0l_head(s0,s1,s2, i121,i122):
    add1 = ""
    add2 = """
f_deltap                %s 12-8         #s2
IP                      %s              #i121
IP                      %s              #i121
""" % (s2, i121,i122,)
    return vb0_low_head(s0,s1,add1,s2,add2)


def vb0l_mo_ma(s0,s1,s2, i121,i122,i123,i124):
    add1 = ""
    add2 = """
SLOOP                   4
IP                      %s %s %s %s     #i121-124
""" % (i121,i122,i123,i124)
    return vb0_low_head(s0,s1,add1,s2,add2)


def vb0l_cho_cher(s0,s1,s1s, s2,s2s, i121,i122,i123,i124,i125,i126):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s)
    add2 = """
f_deltap                %s 12-8         #s2
SHP[rp2]                %s              #s2s
SLOOP                   6
IP                      %s %s %s %s %s %s       #i121-126
""" % (s2, s2s, i121,i122,i123,i124,i125,i126)
    return vb0_low_head(s0,s1,add1,s2,add2)


#------------------------------------------------
def vl0_1(s0,s1,add1):    #do_chada
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      vheight_lu %s   #s1     %s  #add1      
""" % (s0,s1,add1,)

#....................
def vl_do_chada(s0,s1, s1s, s2, s3, i131,i132,i133,i134):
    add1 = """
ALIGNRP                 %s              #s1s
%s                                  #vstem_c1(s2)
MDRP[rnd,grey]          %s              #s3
SLOOP                   4
IP                      %s %s %s %s     #i131,i132,i133,i134
""" % (s1s, vstem_c1(s2), s3, i131,i132,i133,i134,)
    return vl0_1(s0,s1,add1)

def vl_to_patak(s0,s1, s1s1,s1s2, s2,s2s, s3, i131,i132,i133,i134):
    add1 = """
ALIGNRP                 %s              #s1s1
ALIGNRP                 %s              #s1s2
%s                                  #vstem_c1(s2)
SHP[rp2]                %s              #s2s
MDRP[rnd,grey]          %s              #s3
SLOOP                   4
IP                      %s %s %s %s     #i131,i132,i133,i134
""" % (s1s1,s1s2, vstem_c1(s2), s2s, s3, i131,i132,i133,i134,)
    return vl0_1(s0,s1,add1)


#..............................
def vl0_2(s0,s1,add1):    #ru-lu
    return """
SRP0                    %s              #s0
MIRP[rnd,grey]          vheight_lu %s   #s1     %s  #add1      
""" % (s0,s1,add1,)

#....................
def vl0_ru(s0,s1):
    add1 = ""
    return vl0_2(s0,s1,add1)


#------------------------------------------------
def vf_1(s1,add1, s2, i121,i122, add2="",move_2=False):
    if move_2:
        arg_2 = "rp0,rnd,grey"
    else:
        arg_2 = "rnd,grey"
    return """
MIRP[rp0,rnd,grey]      vheight_shoot %s    #s1     %s  #add1
MDRP[%s]        %s                  #s2
f_deltap                %s 12+8                 #s2
IP                      %s                  #i121
IP                      %s                  #i122   %s  #add2
""" % (s1,add1, arg_2, s2, s2, i121,i122, add2)

#....................
def vf_no_nu(s1,s2, i121,i122):
    add1 = ""
    return vf_1(s1,add1, s2, i121,i122)


def vf1_ip(s1, li, s2, i121,i122, add2="",move_2=False):
    add1 = f_ip(li)
    return vf_1(s1,add1, s2, i121,i122, add2, move_2)


def vfr_lo_chula(s1, s2, i121,i122, s3,s4, i341,i342,i343,i344):
    add1 = ""
    add2 = """
MDRP[rp0,min,rnd,grey]  %s                  #s3
MDRP[rnd,grey]          %s                  #s4
SLOOP                   4
IP                      %s %s %s %s         #i341-344
""" % (s3,s4,i341,i342,i343,i344,) 
    return vf_1(s1,add1, s2, i121,i122, add2)


def vfr_tho_thahan(s1,s1s, t2, s2, i121,i122):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,) + vmu2(t2)
    return vf_1(s1,add1, s2, i121,i122)


def vfr_ho_hip(s1,s1s, s2, i121,i122,i123,i124,i125,i126, t2):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,)
    add2 = """
SLOOP                   4
IP                      %s %s %s %s     #i123-i126
""" % (i123,i124,i125,i126,) + vmu2(t2)
    return vf_1(s1,add1, s2, i121,i122, add2, move_2=True)


#------------------------------------------------
def vm_1n(s1,add1):
    return """
MIRP[rp0,rnd,grey]  vheight_num %s      #s1         %s  #add1
""" % (s1, add1)


def vmu1n(s1):
    add1 = ""
    return vm_1n(s1,add1)

def vmu1ns(s1,s1s):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,)
    return vm_1n(s1,add1)


#------------------------------------------------
def vm_2n(s1,add1,stem="vstem_236"):
    return """
MIRP[grey]          %s %s               #stem,s1
SHPIX               16 %s               #s1         %s  #add1
""" % (stem,s1,s1, add1)


def vmu2n(s1):
    add1 = ""
    return vm_2n(s1,add1)

def vmu2ns(s1,s1s):
    return """
MDRP[grey]          %s                  #s1
SHPIX               16 %s               #s1
SHP[rp2]            %s                  #s1s
""" % (s1, s1, s1s,)


#------------------------------------------------
def vm_1(s1,add1):
    return """
MIRP[rp0,rnd,grey]  vheight_shoot %s    #s1         %s  #add1
""" % (s1, add1)

#....................
def vmu1(s1):
    add1 = ""
    return vm_1(s1,add1)

def vmu1_ip(s1, li):
    add1 = f_ip(li)
    return vmu1(s1)


def vmu1_ko_kai(s1, i1,i2,i3,i4,i5,i6):
    add1 = """
SLOOP               6
IP                  %s %s %s %s %s %s       #i1-6
""" % (i1,i2,i3,i4,i5,i6,)
    return vm_1(s1, add1)


#....................
def vm_1s(s1,s1s,add1):
    add1 = """
ALIGNRP             %s                  #s1s
""" % (s1s,) + add1
    return vm_1(s1,add1,)


#,,,,,,,,,,,,,,,,,,,,
def vmu1s(s1,s1s):
    add1 = ""
    return vm_1s(s1,s1s,add1)


def vmu1s_kho_khon(s1,s1s, i1):
    add1 = """
ALIGNRP             %s              #s1s
IP                  %s              #i1
""" % (s1s, i1,)
    return vm_1(s1,add1)


def vmu1s_to_tao(s1,s1s):
    add1 = """
ALIGNRP             %s              #s1s
""" % (s1s, )
    return vm_1(s1,add1)


#------------------------------------------------
def vm_2(s1,add1):
    return """
MIRP[grey]          vstem_258   %s
SHPIX               24          %s
f_deltap            %s 9-2  %s 10-2  %s 11-2  %s 12-2  %s 13-1  %s 14-1   %s  #add1
""" % (s1,s1,s1,s1,s1,s1,s1,s1, add1)


def vmu2(s1):
    add1 = ""
    return vm_2(s1,add1)

def vmu2s(s1,s1s):
    add1 = """
SHP[rp2]            %s                      #s1s
""" % (s1s,)
    return vm_2(s1,add1)


#------------------------------------------------
def vm3(s1, i1):
    return """
MDRP[rp0,min,rnd,grey]  %s                  #s1
IP                      %s                  #i1
""" % (s1,i1,)


#------------------------------------------------
def vm_head(s1,add1, s2,add2, i121,i122,add3=""):
    return """
MDRP[rp0,min,rnd,white] %s              #s1     %s  #add1
MDRP[rnd,grey]          %s              #s2     %s  #add2
IP                      %s              #i121
IP                      %s              #i122   %s  #add3
""" % (s1,add1, s2,add2, i121,i122,add3)


#,,,,,,,,,,,,,,,,,,,,
def vmh_kho_khwai(s1,s2, i121,i122):
    add1 = """
f_deltap                %s 12-8  %s 19+8
""" % (s1,s1,)
    add2 = ""
    return vm_head(s1,add1, s2,add2, i121,i122)


def vmh_kho_khon(s1,s2, i121,i122):
    add1 = add2 = ""
    return vm_head(s1,add1, s2,add2, i121,i122)


def vmh_do_dek(s1,s2, i121,i122):
    add1 = add2 = ""
    add3 = """
SHPIX                   -24 %s          #i122
""" % (i122,)
    return vm_head(s1,add1, s2,add2, i121,i122,add3)


def vmh_cho_chan(s1,s2, i121,i122):
    add1 = ""
    add2 = """
f_deltap                %s 12+8
""" % (s2,)
    return vm_head(s1,add1, s2,add2, i121,i122)

def vmh_o_ang(s1,s2, i121,i122):
    add1 = """
f_deltap                %s 9-8
""" % (s1,)
    add2 = """
f_deltap                %s 12+8
""" % (s2,)
    return vm_head(s1,add1, s2,add2, i121,i122)

def vmh_ho_nokhuk(s1,s2, i121,i122):
    add1 = """
f_deltap                %s 9-8  %s 12-8  
""" % (s1,s1,)
    add2 = """
f_deltap                %s 12+8
""" % (s2,)
    return vm_head(s1,add1, s2,add2, i121,i122)


def vmh_tho_than(s1, i011,i012,i013,i014,i015, s2, i121,i122):
    add1 = """
f_deltap                %s 10+8  %s 13+8  %s 17+8  %s 21+8  
SLOOP                   5
IP                      %s %s %s %s %s  #i011-015
""" % (s1,s1,s1,s1, i011,i012,i013,i014,i015,)
    add2 = """
f_deltap                %s 12+8  %s 16+8
""" % (s2,s2,)
    return vm_head(s1,add1, s2,add2, i121,i122)


#------------------------------------------------
def vm_4(s1,s2,s3,s4,add4,add5):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
MDRP[rp0,min,rnd,white] %s              #s3
MDRP[rp0,min,rnd,white] %s              #s4     %s  #add4
SHPIX                   -8 %s           #s2
SHPIX                    8 %s           #s3     %s  #add5
""" % (s1,s2,s3, s4,add4, s2,s3, add5,)


#....................
def vm_sara_i(s1,s2,s3,s4):
    add4 = add5 = ""
    return vm_4(s1,s2,s3,s4,add4,add5)


def vm_sara_ii(s1,s2,s3,s4, i341, s5):
    add4 = """
IP                      %s              #i341
""" % (i341,)
    add5 = """
MDRP[min,rnd,grey]      %s              #s5
""" % (s5,)
    return vm_4(s1,s2,s3,s4,add4,add5)


def vm_sara_ue(s1,s2,s3,s4, i341, s5,s6, i561,i562):
    add4 = """
IP                      %s              #i341
""" % (i341,)
    add5 = """
MDRP[rp0,min,rnd,grey]  %s              #s5
MDRP[rnd,grey]          %s              #s6
f_deltap                %s 12-8  %s 13-8  %s 14-8  %s 15-8
IP                      %s              #i561
IP                      %s              #i562
""" % (s5,s6, s6,s6,s6,s6, i561,i562,)
    return vm_4(s1,s2,s3,s4,add4,add5)


def vm_sara_uee(s1,s2,s3,s4, i341,i342, s5,s5s):
    add4 = """
IP                      %s              #i341
IP                      %s              #i342
""" % (i341,i342,)
    add5 = """
MDRP[min,rnd,grey]      %s              #s5
SHP[rp2]                %s              #s5s
""" % (s5,s5s,)
    return vm_4(s1,s2,s3,s4,add4,add5)



#------------------------------------------------
def vr1(s1,move_rp0=False):
    if move_rp0:
        return """
MIRP[rp0,rnd,grey]      vheight %s
""" % (s1,)
    else:
        return """
MIRP[rnd,grey]          vheight %s
""" % (s1,)

def vr1_po(s1):
    return """
MIRP[rnd,grey]          vheight_po %s
""" % (s1,)

#------------------------------------------------
def vr2(s1):
    return """
MIRP[grey]              vstem_236   %s
SHPIX                   24          %s
""" % (s1,s1)

#------------------------------------------------
def vf_kho_khai(s1, s2, s3, i1, i2):
    t = ""
    t += """
MIRP[rp0,rnd,grey]      vheight_shoot %s    #s1= 21
MDRP[grey]              %s                  #s2= 10
SHPIX                   24  %s
MDRP[rnd,grey]          %s                  #s3= 15
f_deltap                %s 16+8  %s 17+8  %s 21+8
IP                      %s                  #i1= 46
IP                      %s                  #i2= 40
%s                                      #h_exp_head_2(i1)
""" % (s1, s2, s2, s3, s3,s3,s3,  i1,i2, h_exp_head_2(i1))
    return t

#------------------------------------------------
def vf_2(s1,s1s,add1, s2,s2s, s3,i13, s4,s5, i451,i452):
    return """
MIRP[rp0,rnd,grey]      vheight_shoot %s    #s1 
ALIGNRP                 %s                  #s1s    %s  #add1
MDRP[grey]              %s                  #s2 
SHPIX                   24  %s                      #s2
SHP[rp2]                %s                  #s2s
MDRP[min,rnd,grey]      %s                  #s3
IP                      %s                  #i13
SHPIX                   -24 %s                      #i13
SHPIX                   -24 %s                      #s3
MDRP[rp0,rnd,grey]      %s                  #s4
f_deltap                %s 9+8  %s 10+8  %s 11+8  %s 14+8  %s 15+8  %s 16+8  %s 17+8
MDRP[rnd,grey]          %s                  #s5
IP                      %s                  #i451
IP                      %s                  #i452
%s                                          #h_exp_head_2(i451)
""" % (s1,s1s,add1, s2,s2,s2s, s3,i13, s3,i13, s4, s4,s4,s4,s4,s4,s4,s4, s5, i451,i452, h_exp_head_2(i451))

#,,,,,,,,,,,,,,,,,,,,
def vf_kho_khuat(s1,s1s, s2,s2s, s3,i13, s4,s5, i451,i452):
    add1 = ""
    return vf_2(s1,s1s,add1, s2,s2s, s3,i13, s4,s5, i451,i452)


def vfr_tho_nangmontho(s1,s1s, e11,e12, s2,s2s, s3,i13, s4,s5, i451,i452):
    add1 = """
ALIGNRP                 %s                  #e11
""" % (e11) + vr2(e12)
    return vf_2(s1,s1s,add1, s2,s2s, s3,i13, s4,s5, i451,i452)


#------------------------------------------------
def hf_9(s0,s1,s2,s3,s4,add4, s5,add5, s6, i561,i562,i563):
    return """
SRP0                %s              #s0= 51
MIRP[rp0,rnd,white] gap_113 %s      #s1= 32
f_deltap            %s 11-8
MIRP[min,rnd,grey]  hstem   %s      #s2= 8
SHPIX               -12     %s          #s2
f_deltap            %s 20-2
MDRP[rp0,rnd,grey]  %s              #s3= 29
f_deltap    %s 16+8 %s 17+8 %s 18+8 %s 19+8 %s 20+8
MIRP[min,rnd,grey]  hstem   %s      #s4= 28     %s  #add4
SRP0                %s                  #s1
MDRP[rp0,rnd,grey]  %s              #s5= 17
f_deltap            %s 12-8                     %s  #add5 
MDRP[rnd,grey]      %s              #s6= 23
f_deltap            %s 13-8  %s 32-8
IP                  %s              #i561= 48
IP                  %s              #i562= 42
IP                  %s              #i563= 14
f_deltap            %s 13-4             #s5
""" % (s0, s1, s1, s2, s2,s2, s3, s3,s3,s3,s3,s3, s4,add4, s1, s5, s5,add5, s6, s6,s6, i561,i562,i563, s5, )

def hf_do_dek(s0,s1,s2,s3,s4,i34, s5,s6, i561,i562,i563):
    add4 = """
IP                  %s              #i34
f_deltap            %s 18-4  %s 19-4  %s 20-6     #i34
""" % tuple((i34,)*4)
    add5 = ""
    return hf_9(s0,s1,s2,s3,s4,add4, s5,add5, s6, i561,i562,i563)

def hf_kho_khwai(s0,s1,s2,s3,s4, s5,i35, s6, i561,i562,i563):
    add4 = ""
    add5 = """
IP                  %s              #i35= 11
""" % (i35,)
    return hf_9(s0,s1,s2,s3,s4,add4, s5,add5, s6, i561,i562,i563) + """
%s                                  #h_exp_head_1(i561)
""" % (h_exp_head_1(i561),)


#------------------------------------------------
def hf_ngo_ngu(s0,s1):
    return """
SRP0                %s              #s0=    35
MDRP[min,rnd,grey]  %s              #s1=    3
f_deltap            %s 9-8
""" % (s0,s1,s1,)


#------------------------------------------------
def hx_cho_chan(s1,s2, i121, s3):
    return """
SRP1                %s              #s1=    11
SRP2                %s              #s2=    13
IP                  %s              #i121=  12
SRP0                %s                      #i121
MDRP[grey]          %s              #s3=    2
""" % (s1,s2,i121, i121, s3)


def vx_cho_chan(s1):
    return """
f_deltap            %s 13-4  %s 14-4  %s 15-4  %s 16-4      #s1
""" % tuple((s1,)*4)


#------------------------------------------------
def vr_cho_chang(s1, i1,i2,i3):
    return """
MDRP[rnd,grey]      %s              #s1
SLOOP               3
IP                  %s %s %s        #i1-3
""" % (s1,i1,i2,i3)


#------------------------------------------------
def hr_cho_cher(s0,s1,s2,s2s, s3,s4, r4, s5,s6, i561,i562):
    add1 = ""
    add2 = ""
    return """
%s                                      #hrs_162()
MDRP[rp0,rnd,grey]      %s              #s3
f_deltap                %s 21+8             #s3
MIRP[min,rnd,grey]      hstem %s        #s4
SRP1                    %s              #r4
SRP2                    %s              #s4
IP                      %s              #s5
MDAP[rnd]               %s              #s5
MDRP[rnd,grey]          %s              #s6
IP                      %s              #i561
IP                      %s              #i562
%s                                      #h_exp_head_2(i562)
""" % (hrs_162(s0,s1,add1, s2,s2s, add2), s3, s3, s4, r4,s4, s5, s5, s6, i561, i562, h_exp_head_2(i562),) 


#------------------------------------------------
def hadd_no_nen(s1,s1s,s2):
    return """
MDRP[rp0,rnd,grey]      %s              #s1
ALIGNRP                 %s              #s1s
MIRP[min,rnd,grey]      hstem %s        #s2
""" % (s1,s1s,s2,)


#------------------------------------------------
def hadd_tho_thahan(s1,s2,s3,s4):
    return """
SRP1                    %s              #s1
SRP2                    %s              #s2
IP                      %s              #s3
SRP0                    %s              #s3
MDRP[grey]              %s              #s4
""" % (s1,s2,s3,s3,s4)


#------------------------------------------------
def hf_tho_thong(s0,s1,t1, s2, s3):
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     gap_88 %s       #s1
f_deltap                %s 12-8  %s 13-8
MDRP[grey]              %s              #t1
SHPIX                   -24 %s          #t1
MDRP[rp0,rnd,grey]      %s              #s2
f_deltap                %s 11+8             #s2
MIRP[min,rnd,grey]      hstem %s        #s3
""" % (s0,s1, s1,s1, t1,t1, s2, s2, s3)

def hr_tho_thong(s0,s1,t1,s2):
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,white]     gap_88 %s       #s1
f_deltap                %s 9-8  %s 10-8  %s 11-8    #s1
MDRP[grey]              %s              #t1
MIRP[min,rnd,grey]      hstem %s        #s2
""" % (s0,s1, s1,s1,s1, t1,s2)

def vmh_tho_thong(s1, i011,i012,i013,i014,i015):
    return """
MDRP[rnd,grey]          %s              #s1
SLOOP                   5
IP                      %s %s %s %s %s  #i011-015
""" % (s1, i011,i012,i013,i014,i015)


#------------------------------------------------
def vadd_yo_yak(s1,s2, i12,s3, i123):
    return """
SRP1                    %s              #s1
SRP2                    %s              #s2
IP                      %s              #i12
MDAP[rnd]               %s              #i12
MIRP[grey]              vstem_236 %s    #s3
SHPIX                   -16 %s          #s3
IP                      %s              #i123
""" % (s1,s2, i12,i12, s3, s3, i123,)


#------------------------------------------------
def vadd_lo_ling(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MIRP[grey]              vstem_236 %s    #s2
SHPIX                   16 %s           #s2
#
f_deltap                %s 10-8  %s 10-8  %s 17-8  %s 17-6    #s1,s2
""" % (s1, s2, s2, s1,s2,s1,s2)


#------------------------------------------------
def hadd_so_rusi(s1,s2, i121,i122):
    return """
MDAP[rnd]               %s              #s1
MDRP[grey]              %s              #s2
IP                      %s              #i121
IP                      %s              #i122
""" % (s1,s2, i121,i122)

def vadd_so_rusi(s1,s2, i121,i122,i123,i124,i125,i126):
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #s2
SLOOP                   6
IP                      %s %s %s %s %s %s   #i121-126
""" % (s1,s2, i121,i122,i123,i124,i125,i126)


def vadd_paiyan_noi(s1s, i1,i2, s2, s3, i231, i232):
    return """
ALIGNRP                 %s              #s1s
IP                      %s              #i1
IP                      %s              #i2
MDRP[rp0,rnd,grey]      %s              #s2
f_deltap                %s 12-8         #s2
IP                      %s              #i231
IP                      %s              #i232
MDRP[grey]              %s              #s3
""" % (s1s, i1,i2, s2,s2, i231,i232, s3,)


#================================================
def hf_sara_a(s0, s1,s1s, s2,s2s, i121,i122, i12s1,i12s2, s3,s3s):
    return """
SRP0                    %s              #s0
MIRP[rp0,rnd,grey]      gap_88 %s       #s1
ALIGNRP                 %s              #s1s
%s                                  #head0s(s2,i121,i122,i12s1,i12s2)
MDRP[rnd,grey]          %s              #s3
SHP[rp2]                %s              #s3s
""" % (s0,s1, s1s, head0s(s2,s2s,i121,i122,i12s1,i12s2), s3,s3s)


def vm_sara_a(s1, s2, s3, i131,i132, s4, s5, i451,i452, s6):
    return """
MDRP[rp0,rnd,grey]      %s              #s1
%s                                  #vstem_c1(s2)
%s                                  #head11(s3, i131,i132)
%s                                  #vr1(s4,move_rp0=True)
%s                                  #head21(s5, i451,i452, move_rp0=True)
%s                                  #vstem_c1(s6)
""" % (s1, vstem_c1(s2), head11(s3, i131,i132), vr1(s4,move_rp0=True), head21(s5, i451,i452, move_rp0=True), vstem_c1(s6),)


#..............................
def vr_2(s0,s1,add1, s2, i121,i122,add2, s3):
    return """
MDAP[rnd]               %s              #s0
MDRP[rp0,min,rnd,grey]  %s              #s1     %s  #add1
MDRP[rp0,rnd,grey]      %s              #s2
IP                      %s              #i121
IP                      %s              #i122   %s  #add2
MDRP[min,rnd,grey]      %s              #s3
SHPIX                   8 %s            #s3
""" % (s0,s1,add1, s2, i121,i122,add2, s3,s3,)


#....................
def vr_sara_u(s0,s1,s2, i121,i122, s3):
    add1 = add2 = ""
    return vr_2(s0,s1,add1,s2, i121,i122, add2, s3)


def vr_sara_uu(s0, s1,s1s, s2, i121,i122, s2s, s3):
    add1 = """
ALIGNRP                 %s              #s1s
""" % (s1s,)
    add2 = """
ALIGNRP                 %s              #s2s
""" % (s2s,)
    return vr_2(s0,s1,add1,s2, i121,i122, add2, s3)


#..............................
def hr_mai_hanakat(s1,s2, i121,i122, s3):
    return """
MDAP[rnd]               %s              #s1
%s                                  #head0(s2, i121,i122)
MDRP[rnd,grey]          %s              #s3
""" % (s1, head0(s2, i121,i122), s3,)

def vm_mai_hanakat(s1,s2, s3, i131,i132):
    return """
MDAP[rnd]               %s              #s1
%s                                  #vstem_11(s2)
%s                                  #head01(s3, i131,i132)
""" % (s1,vstem_11(s2), head01(s3, i131,i132),)


#..............................
def hr_phinthu(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
""" % (s1,s2,)


def vr_phinthu(s0,s1,s2):
    return """
MDAP[rnd]               %s              #s0
MDRP[rp0,min,rnd,white] %s              #s1
MDRP[min,rnd,grey]      %s              #s2
""" % (s0,s1,s2,)


#..............................
def hf_baht(s0,s1, s2,s2s, s3,s3s1,s3s2,s3s3, s4,s4s1,s4s2,s4s3, s5,s6,s7,s8):
    add1 = """
f_deltap    %s 9-8  %s 10-8  %s 20-8
""" % (s1, s1, s1,)
    temp = """
f_deltap    %s 15+8  %s 16+8  %s 24+8  %s 25+8
"""
    add3 = temp % (s3,s3,s3,s3,)
    add5 = temp % (s5,s5,s5,s5,)

    return """
SRP0                    %s              #s0
MDRP[rp0,rnd,white]     %s              #s1     %s  #add1
MIRP[rp0,min,rnd,grey]  hstem %s        #s2
ALIGNRP                 %s              #s2s
MDRP[rp0,min,rnd,white] %s              #s3     %s  #add3
ALIGNRP                 %s              #s3s1
ALIGNRP                 %s              #s3s2
ALIGNRP                 %s              #s3s3
MDRP[rp0,min,rnd,grey]  %s              #s4
ALIGNRP                 %s              #s4s1
ALIGNRP                 %s              #s4s2
ALIGNRP                 %s              #s4s3
MDRP[rp0,min,rnd,grey]  %s              #s5     %s  #add5
MIRP[min,rnd,grey]      hstem %s        #s6
MDRP[rp0,rnd,grey]      %s              #s7
MIRP[min,rnd,grey]      hstem %s        #s8
""" % (s0,s1,add1, s2,s2s, s3,add3,s3s1,s3s2,s3s3, s4,s4s1,s4s2,s4s3, s5,add5,s6,s7,s8)

def vm_baht(s0,s0s, l0, s1,s1s, s2,s2s, t2, s3,s3s, s4,s4s, s5,s5s, i451):
    return """
MDAP[rnd]               %s              #s0
ALIGNRP                 %s              #s0s
MDRP[min,rnd,grey]      %s              #l0
%s                                  #vstem_c1s(s1,s1s)
MDRP[rp0,rnd,grey]      %s              #s2
ALIGNRP                 %s              #s2s
MDRP[min,rnd,grey]      %s              #t2
%s                                  #vstem_c2s(s3,s3s)
SRP1                    %s              #s2
SRP2                    %s              #s1
IP                      %s              #s4
MDAP[rnd]               %s              #s4
ALIGNRP                 %s              #s4s
%s                                  #vstem_c2s(s5,s5s)
IP                      %s              #i451
""" % (s0,s0s, l0, vstem_c1s(s1,s1s),s2,s2s,t2,vstem_c2s(s3,s3s),s2,s1,s4,s4,s4s,vstem_c2s(s5,s5s),i451,)


#..............................
def vm_sara_o(s1,s2):
    return """
MDAP[rnd]               %s              #s1
%s                                  #vstem_c2(s2)
""" % (s1,vstem_c2(s2),)

#..............................
def hf_sara_ai_maimuan(s0,s1,s2, i121,i122, s3,s4):
    return """
SRP0                    %s              #s0
MDRP[rp0,rnd,white]     %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
IP                      %s              #i121
IP                      %s              #i122
MDRP[rp0,min,rnd,white] %s              #s3
MDRP[min,rnd,grey]      %s              #s4
""" % (s0, s1,s2, i121,i122, s3,s4,)

def vm_sara_ai_maimuan(s1,s2,s3,s4, i341,i342, s0, i401,i402):
    return """
MDAP[rnd]               %s              #s1
%s                                  #vstem_c2(s2)
MDRP[rp0,rnd,grey]      %s              #s3
%s                                  #head02(s4, i341,i342)
SRP1                    %s              #s4
SRP2                    %s              #s0
IP                      %s              #i401
IP                      %s              #i402
""" % (s1, vstem_c2(s2), s3, head02(s4, i341,i342), s4,s0, i401,i402,)


#..............................
def hadd_sara_ai_maimalai(s2, i121,i122,i123):
    return """
MDRP[rnd,grey]          %s              #s2
IP                      %s              #i121
IP                      %s              #i122
IP                      %s              #i123
""" % (s2, i121,i122,i123,)


def vm_sara_ai_maimalai(s1,s2, t1 ,s3,s4):
    return """
MDAP[rnd]               %s              #s1
%s                                  #vstem_c2(s2)
MDRP[grey]              %s              #t1
MDRP[rp0,rnd,grey]      %s              #s3
%s                                  #vstem_c1(s4)
""" % (s1, vstem_c2(s2), t1, s3, vstem_c1(s4),)


#..............................
def hr_maitaikhu(s1,s2, i121,i122, s3,s4):
    return """
MDAP[rnd]               %s              #s1
MDRP[rnd,grey]          %s              #s2
IP                      %s              #i121
IP                      %s              #i122
MDRP[rp0,rnd,grey]      %s              #s3
MDRP[min,rnd,grey]      %s              #s4
SHPIX                   8 %s            #s3
SHPIX                   -16 %s          #s4
""" % (s1,s2, i121,i122, s3,s4,s3,s4)

def vm_maitaikhu(s1,s1s,s2, i121,i122,i123, s3,i131,i132, s4,s5):
    return """
MDAP[rnd]               %s              #s1
ALIGNRP                 %s              #s1s
MDRP[rnd,grey]          %s              #s2
IP                      %s              #i121
IP                      %s              #i122
IP                      %s              #i123
MDRP[rp0,rnd,grey]      %s              #s3
IP                      %s              #i131
IP                      %s              #i132
MDRP[rp0,min,rnd,white] %s              #s4
MDRP[min,rnd,grey]      %s              #s5
SHPIX                   -8 %s           #s5
SHPIX                    8 %s           #s4
SHPIX                   -16 %s          #i121
SHPIX                   -16 %s          #i122
SHPIX                    8 %s           #i123
SHPIX                    8 %s           #s1
SHPIX                    8 %s           #s1s
""" % (s1,s1s,s2, i121,i122,i123, s3,i131,i132, s4,s5,s5,s4,i121,i122,i123,s1,s1s,)


#..............................
def hr_mai_ek(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
SHPIX                   8 %s            #s2
SHPIX                   -8 %s           #s1
""" % (s1,s2,s2,s1,)

def vm_mai_ek(s1,s2):
    return """
MDAP[rnd]               %s              #s1
MDRP[min,rnd,grey]      %s              #s2
""" % (s1,s2,)


#..............................
def hr_mai_tho(s1, s2,t2, s3, i231,i232):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
MDRP[rnd,grey]          %s              #t2
MDRP[rnd,grey]          %s              #s3
IP                      %s              #i231
IP                      %s              #i232
""" % (s1,s2,t2,s3,i231,i232,)

def vm_mai_tho(s1,s2,s3, i231,i232):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
MDRP[rnd,grey]          %s              #s3
IP                      %s              #i231
IP                      %s              #i232
SHPIX                   -8 %s           #s2
SHPIX                   8 %s            #s1
""" % (s1,s2,s3, i231,i232, s2,s1)


#..............................
def hr_mai_tri(s1,s2,s3,s4, i341,i342):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
MDRP[rp0,min,rnd,white] %s              #s3
MDRP[min,rnd,grey]      %s              #s4
IP                      %s              #i341
IP                      %s              #i342
SHPIX                   -16 %s          #i341
SHPIX                   8 %s            #s2
SHPIX                   -8 %s           #s1
""" % (s1,s2,s3,s4,i341,i342,i341,s2,s1,)

def vm_mai_tri(s1,s1s,s2,s3, i131,i132, s4,s4s,s5,s5s):
    return """
MDAP[rnd]               %s              #s1
ALIGNRP                 %s              #s1s
MDRP[min,rnd,grey]      %s              #s2
MDRP[rp0,min,rnd,grey]  %s              #s3
IP                      %s              #i131
IP                      %s              #i132
MDRP[rp0,rnd,grey]      %s              #s4
ALIGNRP                 %s              #s4s
MDRP[grey]              %s              #s5
SHP[rp2]                %s              #s5s
SHPIX                   -8 %s           #s2
""" % (s1,s1s,s2,s3,i131,i132,s4,s4s,s5,s5s,s2,)


#..............................
def hr_mai_chattawa(s1,s1s,s2,s2s):
    return """
MDAP[rnd]               %s              #s1
ALIGNRP                 %s              #s1s
MDRP[min,rnd,grey]      %s              #s2
SHP[rp2]                %s              #s2s
SHPIX                   8 %s            #s2
SHPIX                   8 %s            #s2s
SHPIX                   -8 %s           #s1
SHPIX                   -8 %s           #s1s
""" % (s1,s1s,s2,s2s,s2,s2s,s1,s1s,)

def vm_mai_chattawa(s1,s2,s2s,s3,s3s):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
ALIGNRP                 %s              #s2s
MDRP[min,rnd,grey]      %s              #s3
SHP[rp2]                %s              #s3s
SHPIX                   8 %s            #s2
SHPIX                   8 %s            #s2s
SHPIX                   -8 %s           #s3
SHPIX                   -8 %s           #s3s
""" % (s1,s2,s2s,s3,s3s,s2,s2s,s3,s3s,)


#..............................
def hr_thanthakhat(s1,s2, i121,i122):
    return """
MDAP[rnd]               %s              #s1
%s                                  #head0(s2)
""" % (s1,head0(s2,i121,i122),)


def vm_thanthakhat(s1,s2, i121,i122, s3):
    return """
MDAP[rnd]               %s              #s1
%s                                  #head02m(s2, i121,i122)
MDRP[min,rnd,grey]      %s              #s3
SHPIX                   8 %s            #s3
""" % (s1, head02m(s2, i121,i122), s3,s3,)


#..............................
def hr_yamakkan(s1,s2, i121,i122, s3, i231, s4,s5):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
IP                      %s              #i121
IP                      %s              #i122
MDRP[min,rnd,grey]      %s              #s3
IP                      %s              #i231
MDRP[rp0,rnd,grey]      %s              #s4
MDRP[min,rnd,grey]      %s              #s5
%s      #dx_1(s2)
%s      #dx_1(s4)
""" % (s1,s2,i121,i122,s3,i231,s4,s5,dx_1(s2),dx_1(s4),)


def vm_yamakkan(s1,s2,s3,s4,i341,s5,s6):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,rnd,grey]      %s              #s2
MDRP[rp0,rnd,white]     %s              #s3
MDRP[rp0,rnd,grey]      %s              #s4
IP                      %s              #i341
MDRP[rp0,rnd,white]     %s              #s5
MDRP[rp0,rnd,grey]      %s              #s6
%s      #dx_1(s2)
%s      #dx_1(s4)
%s      #dx_1(s6)
%s      #dx_2(s1)
%s      #dx_2(s3)
%s      #dx_2(s5)
""" % (s1,s2,s3,s4,i341,s5,s6, dx_1(s2),dx_1(s4),dx_1(s6),dx_2(s1),dx_2(s3),dx_2(s5),)


#..............................
def hv_fongman(s1,s2,s3,s4,s5,s6,s7,s8):
    return """
MDAP[rnd]               %s              #s1
MDRP[rp0,min,rnd,grey]  %s              #s2
MDRP[rp0,min,rnd,white] %s              #s3
SRP0                    %s              #s1
MDRP[rp0,rnd,grey]      %s              #s8
MDRP[rp0,min,rnd,grey]  %s              #s7
MDRP[rp0,min,rnd,white] %s              #s6
SRP1                    %s              #s3
SRP2                    %s              #s6
IP                      %s              #s4
IP                      %s              #s5
""" % (s1,s2,s3,s1,s8,s7,s6,s3,s6,s4,s5,)

#..............................
def hadd_one(s1,s2, i121,i122):
    return """
MDRP[rp0,rnd,white]     %s              #s1
%s                                  #head0(s2, i121,i122)
""" % (s1, head0(s2,i121,i122),)

def vadd_one(s0,s1):
    return """
SRP0                    %s              #s0
MDRP[rp0,grey]          %s              #s1
""" % (s0,s1,)

#..............................

def vadd_two(s0,s1):
    return """
SRP0                    %s              #s0
MDRP[rp0,grey]          %s              #s1
""" % (s0,s1,)

#================================================
pseudo_code_dict = {

    'uni0E01':      #KO KAI
        "%s" % ('\n'.join([""
        , hf_ko_kai(26,14, 18, 12, 17,8)
        , hr_ko_kai(27,25, 1)
        , ix()
        #y
        , sy()
        , vs0(1,13)
        , vmu1_ko_kai(22, 17,18,19,8,9,10)
        , vmu2(5)
        , iy()
        , sx_notch_1(19)
        ]),),

    'uni0E02':    #KHO KHAI
        "%s" % ('\n'.join([""
        , hf_kho_khai(52, 18,12, 49,43,10)
        , hr_kho_khai(53, 36,34, 29,1, 24,7)
        , ix()
        , h_dry_head_1(12)
        #y
        , sy()
        , vb0(0,31)
        , vr1(36)
        , vf_kho_khai(21,10,15, 46,40)
        , iy()
        ]),),

    'uni0E03':    #KHO KHUAT
        "%s" % ('\n'.join([""
        , hf_kho_khuat(58, 22,16, 55,49,13)
        , hr_kho_khuat(59, 42,40, 35,1, 30,7)
        , add_ip(22,30, [25,26,27,9,10,11])
        , ix()
        , h_dry_head_1(16)
        #y
        , sy()
        , vb0(0,37)
        , vr1(42)
        , vf_kho_khuat(27,25, 9,11, 10,26, 13,19, 52,46)
        , iy()
        ]),),

    'uni0E04':    #KHO KHWAI
        "%s" % ('\n'.join([""
        , hf_kho_khwai(51,32,8, 29,28, 14,11, 20, 48,42,25)
        , hr_kho_khwai(52,38,1)
        , ix()
        , h_dry_head_12(16,18,22)
        #y
        , sy()
        , vs0(1,28)
        , vmu1_ip(35, [11])
        , vmu2(5)
        , vmh_kho_khwai(17,23, 45,39)
        , iy()
        , groove_1(11)
        ]),),

    'uni0E05':    #KHO KHON
        "%s" % ('\n'.join([""
        , hf_kho_khwai(54,33,9, 30,29, 15,12, 21, 51,45,26)
        , hr_kho_khwai(55,41,1)
        , add_ip(9,2, [36,37,38,4,5,6,7])
        , ix()
        , h_dry_head_12(17,19,23)
        #y
        , sy()
        , vs0(1,29)
        , vmu1s_kho_khon(38,36, 12)
        , vmu2s(4,7)
        , vm3(5,37)
        , vmh_kho_khon(18,24, 48,42)
        , iy()
        , groove_1(12)
        ]),),

    'uni0E06':    #KHO RAKHANG
        "%s" % ('\n'.join([""
        , hf_kho_khuat(77, 34,28, 62,56,26)
        , hr_kho_rakhang(78, 52,50,1, 47,3, 13, 9, 74,68, 42,19)
        , h_exp_head_2(68)
        , ix()
        , dry_1(9)
        #y
        , sy()
        , vb0(0,50)
        , vr1(52)
        , vf_kho_khuat(39,37, 21,23, 22,38, 25,31, 59,53)
        , vb0l_mo_ma(1,6,12, 71,65,48,3)
        , iy()
        ]),),

    'uni0E07':    #NGO NGU
        "%s" % ('\n'.join([""
        , hf_ngo_ngu(35,3)
        , hr_ngo_ngu(36,20,9, 15, 32,26)
        , ix()
        , dry_1(9)
        #y
        , sy()
        , vb0(0,7)
        , vf_no_nu(18,12, 29,23)
        , iy()
        ]),),

    'uni0E08':    #CHO CHAN
        "%s" % ('\n'.join([""
        , hf_cho_chan(44,22,7,12, 41,35,2)
        , hr_cho_chan(45,29,16,1,0,13)
        , ix()
        , hx_cho_chan(11,13, 12, 2)
        , h_dry_head_21(9,5,11)
        #y
        , sy()
        , vb0(0,13)
        , vmu1(26)
        , vmu2(19)
        , vmh_cho_chan(10,4, 38,32)
        , iy()
        , vx_cho_chan(13)
        , sx_notch_1(23)
        ]),),

    'uni0E09':    #CHO CHING
        "%s" % ('\n'.join([""
        , hf_cho_ching(65,7,22, 12,0, 50,44, 1)
        , hr_no_nu(66,33,39, 62,56, 29, 15)
        , ix()
        , h_dry_head_2(7)
        , h_dry_head_12(38,31,35)
        #y
        , sy()
        , vb0(0,13)
        , vmu1(26)
        , vmu2(19)
        , vmh_cho_chan(10,4, 47,41)
        , vb0l_mo_ma(0,36,30, 59,53,15,39)
        , iy()
        , sx_notch_1(23)
        ]),),

    'uni0E0A':    #CHO CHANG
        "%s" % ('\n'.join([""
        , hf_cho_chang(63, 18,12, 60,54,10)
        , hr_cho_chang(64, 47,34, 45, 29,1, 24,7, 37, 42,41)
        , ix()
        , h_dry_head_12(16,11,14)
        , h_exp_head_1(45)
        #y
        , sy()
        , vb0(0,31)
        , vr_cho_chang(42, 38,45,37)
        , vf_kho_khai(21,10,15, 57,51)
        , iy()
        ]),),

    'uni0E0B':    #SO SO
        "%s" % ('\n'.join([""
        , hf_kho_khuat(69, 22,16, 66,60,13)
        , hr_so_so(70, 53,40, 51, 35,1, 30,7, 43, 48,47)
        , add_ip(22,30, [25,26,27,9,10,11])
        , ix()
        , h_dry_head_12(20,14,18)
        , groove_1(51)
        #y
        , sy()
        , vb0(0,37)
        , vr_cho_chang(48, 44,51,43)
        , vf_kho_khuat(27,25, 9,11, 10,26, 13,19, 63,57)
        , iy()
        ]),),

    'uni0E0C':    #CHO CHOE
        "%s" % ('\n'.join([""
        , hf_tho_thung(74,33,37, 23, 36,19, 28, 59,53)
        , hr_cho_cher(75,49,47,1, 44,12, 28, 9, 3, 71,65)
        , ix()
        , dry_1(26)
        , dry_2(11)
        , dry_1(5)
        #y
        , sy()
        , vb0(1,47)
        , vr1(49)
        , vmu1_ko_kai(41, 36,37,38,19,20,21)
        , vmu2(16)
        , vb0l_cho_cher(1,31,6, 25,12, 56,50,68,62,45,3)
        , iy()
        , h_exp_head_1(47)
        , sx_notch_1(38)
        ]),),

    'uni0E0D.descless': #YO YING
        "%s" % ('\n'.join([""
        , hf_tho_thung(50,22,26, 12, 25,8, 17, 47,41)
        , hr_yo_ying(51,37,35,33,1)
        , ix()
        , h_dry_head_1(17)
        #y
        , sy()
        , vb0(1,34)
        , vr1(37)
        , vmu1_ko_kai(30, 25,26,27,8,9,10)
        , vmu2(5)
        , vb0l_head(1,20,14, 44,38)
        , iy()
        , sx_notch_1(27)
        ]),),

    'desc.uni0E0D':
        "%s" % ('\n'.join([""
        , v0(9)
        , head0(3,26,20)
        , ix()
        , h_dry_head_2(3)
        , h_dry_head_1(9)
        #y
        , sy()
        , v0(29)
        , "\nMDRP[rp0,min,rnd,white] 6"
        , head01m(0,23,17)
        , "\nMDRP[min,rnd,grey]  11"
        , iy()
        ]),),

    'uni0E0E':    #DO CHADA
        "%s" % ('\n'.join([""
        , hf_pho_samphao(71,35,29, 43,42,25,60,54, 39)
        , hr_do_chada(72,50,18,1, 8, 69, 65,13,3,16)
        , ix()
        , dry_2(37)
        , dry_2(10)
        , groove_2(65)
        , groove_1(16)
        #y
        , sy()
        , v0(71)
        , vmu1_ko_kai(47, 42,43,44,25,26,27)
        , vmu2(22)
        , vb0l_head(71,32,38, 57,51)
        , vl_do_chada(71,5,1, 18, 11, 16,67,63,3)
        , iy()
        , h_exp_head_2(3)
        , h_exp_head_1(13)
        , h_exp_head_1(18)
        , sx_notch_1(44)
        ]),),

    'uni0E0F':    #TO PATAK
        "%s" % ('\n'.join([""
        , hf_pho_samphao(74,40,34, 48,47,30,63,57, 44)
        , hr_to_patak(75,53,25, 12, 72, 68,17,6,20,22,2)
        , ix()
        , dry_2(42)
        , dry_2(14)
        , groove_2(68)
        , groove_1(20)
        #y
        , sy()
        , v0(74)
        , vmu1_ko_kai(51, 47,48,49,30,31,32)
        , vmu2(28)
        , vb0l_head(74,37,43, 60,54)
        , vl_to_patak(74,9, 4,1, 25,22, 15, 17,70,66,6)
        , iy()
        , h_exp_head_2(2)
        , h_exp_head_2(6)
        , h_exp_head_1(25)
        , h_exp_head_1(22)
        , sx_notch_1(49)
        ]),),

    'uni0E10.descless':    #THO THAN
        "%s" % ('\n'.join([""
        , hf_tho_than(57,19,39, 7, 12, 54,48,2)
        , hr_tho_than(58,42,30,16, 1,0,13)
        , ix()
        , hx_cho_chan(11,13, 12, 2)
        , h_dry_head_21(9,5,11)
        #y
        , sy()
        , vb0(0,13)
        , vmu1(22)
        , vmu2(37)
        , vmh_tho_than(10, 20,39,19,41,17, 4, 51,45)
        , iy()
        , vx_cho_chan(13)
        , sx_notch_1(20)
        ]),),

    'desc.uni0E10':
        "%s" % ('\n'.join([""
        , v0(33)
        , head0(27,45,39)
        , '\nMDRP[min,rnd,grey]  23'
        , '\nMDRP[rp0,rnd,grey]  18'
        , head0(10,54,50)
        , ix()
        , h_dry_head_2(10)
        , h_dry_head_2(27)
        #y
        , sy()
        , v0(56)
        , '\nMDRP[rp0,min,rnd,white] 30'
        , head01m(24,42,36)
        , '\nMDRP[rp0,min,rnd,white] 23'
        , '\nMDRP[rp0,min,rnd,grey]  0'
        , '\nALIGNRP 3\nALIGNRP  7'
        , head0(13,52,48)
        , iy()
        ]),),

    'uni0E11':    #THO NANGMONTHO
        "%s" % ('\n'.join([""
        , hf_kho_khuat(69, 33,27, 66,60,24)
        , hr_tho_nangmontho(70, 56,1, 46,11, 12, 41, 52,6,50,8, 18)
        , ix()
        , h_dry_head_12(31,25,29)
        #y
        , sy()
        , vsb0(11,1,47)
        , vfr_tho_nangmontho(38,36, 54,4, 20,22, 21,37, 24,30, 63,57)
        , iy()
        ]),),

    'uni0E12':    #THO PHUTHAO
        "%s" % ('\n'.join([""
        , hf_do_dek(80,42,20, 39,38,23, 29,35, 65,59,26)
        , hr_cho_cher(81,55,53,1, 50,12, 38, 9, 3, 77,71)
        , add_ip(20,12, [45,46,47,15,16,17,18])
        , ix()
        , h_dry_head_21(31,27,33)
        , h_dry_head_21(10,8,4)
        #y
        , sy()
        , vsb0s(1,38, 53,23)
        , vr1(55)
        , vmu1s_to_tao(47,45)
        , vmu2s(15,18)
        , vm3(16,46)
        , vmh_do_dek(32,26, 62,56)
        , vb0l_mo_ma(1,6,12, 74,68,51,3)
        , iy()
        ]),),

    'uni0E13':    #NO NEN
        "%s" % ('\n'.join([""
        , hf_tho_thung(74,22,26, 12, 25,8, 17, 59,53)
        , hr_no_nu(75,42,48, 71,65, 38, 36)
        , hadd_no_nen(33,0, 1)
        , ix()
        , dry_1(15)
        , dry_2(46)
        #y
        , sy()
        , vb0(1,34)
        , vr1(38)
        , vmu1_ko_kai(30, 25,26,27,8,9,10)
        , vmu2(5)
        , vb0l_cho_cher(1,20,45, 14,39, 56,50,68,62,36,48)
        , iy()
        , h_exp_head_1(34)
        , sx_notch_1(27)
        ]),),

    'uni0E14':    #DO DEK
        "%s" % ('\n'.join([""
        , hf_do_dek(49,30,8, 27,26,11, 17,23, 46,40,14)
        , hr_kho_khwai(50,36,1)
        , ix()
        , h_dry_head_21(19,13,21)
        #y
        , sy()
        , vsb0(1,26, 11)
        , vmu1(33)
        , vmu2(5)
        , vmh_do_dek(20,14, 43,37)
        , iy()
        ]),),

    'uni0E15':    #TO TAO
        "%s" % ('\n'.join([""
        , hf_do_dek(52,31,9, 28,27,12, 18,24, 49,43,15)
        , hr_kho_khwai(53,39,1)
        , ix()
        , h_dry_head_21(20,16,22)
        #y
        , sy()
        , vsb0(1,27, 12)
        , vmu1s(36,34)
        , vmu2s(4,7)
        , vm3(5,35)
        , vmh_do_dek(21,15, 46,40)
        , iy()
        ]),),

    'uni0E16':    #THO THUNG
        "%s" % ('\n'.join([""
        , hf_tho_thung(46,22,26, 12, 25,8, 17, 43,37)
        , hr_ko_kai(47,33, 1)
        , ix()
        , dry_1(15)
        #y
        , sy()
        , v0(1)
        , vmu1_ko_kai(30, 25,26,27,8,9,10)
        , vmu2(5)
        , vb0l_head(1,20,14, 40,34)
        , iy()
        , sx_notch_1(27)
        ]),),

    'uni0E17':    #THO THAHAN
        "%s" % ('\n'.join([""
        , hf_tho_thahan(39,13, 18,7, 36,30, 8)
        , hr_tho_thahan(40,26,1)
        , hadd_tho_thahan(18,1, 6, 20)
        , ix()
        , dry_2(11)
        #y
        , sy()
        , vs0(1,7)
        , vfr_tho_thahan(16,23, 4, 10, 33,27)
        , iy()
        , groove_1(19)
        ]),),

    'uni0E18':    #THO THONG
        "%s" % ('\n'.join([""
        , hf_tho_thong(39,12,32, 1,3)
        , hr_tho_thong(40,35,23,8)
        , ix()
        #y
        , sy()
        , vb0(0,5)
        , vmu1(15)
        , vmu2(30)
        , vmh_tho_thong(2, 12,13,32,34,10)
        , iy()
        ]),),

    'uni0E19':    #NO NU
        "%s" % ('\n'.join([""
        , hf_no_nu(52,6, 11,0, 37,31, 1)
        , hr_no_nu(53,20,26, 49,43, 16, 14)
        , ix()
        , h_dry_head_2(6)
        , dry_2(24)
        #y
        , sy()
        , vb0(0,12)
        , vr1(16)
        , vf_no_nu(9,3, 34,28)
        , vb0l_mo_ma(0,23,17, 14,26,46,14)
        , iy()
        , groove_1(12)
        ]),),

    'uni0E1A':    #BO BAIMAI
        "%s" % ('\n'.join([""
        , hf_bo_baimai(36,8, 13, 33,27, 3, 1)
        , hr_bo_baimai(37,20,18)
        , ix()
        , h_dry_head_2(8)
        #y
        , sy()
        , vb0s(0,15, 3)
        , vr1(20)
        , vf_no_nu(11,5, 30,24)
        , iy()
        ]),),

    'uni0E1B':    #PO PLA
        "%s" % ('\n'.join([""
        , hf_bo_baimai(36,8, 13, 33,27, 3, 1)
        , hr_bo_baimai(37,20,18)
        , ix()
        , h_dry_head_2(8)
        #y
        , sy()
        , vb0s(0,15, 3)
        , vr1_po(20)
        , vf_no_nu(11,5, 30,24)
        , iy()
        ]),),

    'uni0E1C':    #PHO PHUNG
        "%s" % ('\n'.join([""
        , hf_pho_phung(33,4, 14,3, 10, 30,24)
        , hr_mo_ma(34,20,18,1)
        , add_ip(14,18, [16,17,2])
        , ix()
        , dry_1(12)
        #y
        , sy()
        , vbs1s(1,3, 18,15)
        , vr1(20)
        , vf_no_nu(7,13, 27,21)
        , add_ip(13,1, [17,2])
        , "f_deltap    2 15+4  2 16+8\n"
        , iy()
        , groove_2(2)
        ]),),

    'uni0E1D':    #FO FA
        "%s" % ('\n'.join([""
        , hf_pho_phung(33,4, 14,3, 10, 30,24)
        , hr_mo_ma(34,20,18,1)
        , add_ip(14,18, [16,17,2])
        , ix()
        , dry_1(12)
        #y
        , sy()
        , vbs1s(1,3, 18,15)
        , vr1_po(20)
        , vf_no_nu(7,13, 27,21)
        , add_ip(13,1, [17,2])
        , "f_deltap    2 15+4  2 16+8\n"
        , iy()
        , groove_2(2)
        ]),),

    'uni0E1E':    #PHO PHAN
        "%s" % ('\n'.join([""
        , hf_pho_phan(33,9, 14,3, 30,24, 4)
        , hr_pho_phan(34,20,18,1)
        , add_ip(14,18, [16,17,2])
        , ix()
        , h_dry_head_2(9)
        #y
        , sy()
        , vbs1s(1,3, 18,15)
        , vr1(20)
        , vf1_ip(12, [17,2], 6, 27,21)
        , "f_deltap    2 15+4  2 16+8\n"
        , iy()
        , groove_2(2)
        ]),),

    'uni0E1F':    #FO FUN
        "%s" % ('\n'.join([""
        , hf_pho_phan(33,9, 14,3, 30,24, 4)
        , hr_pho_phan(34,20,18,1)
        , add_ip(14,18, [16,17,2])
        , ix()
        , h_dry_head_2(9)
        #y
        , sy()
        , vbs1s(1,3, 18,15)
        , vr1_po(20)
        , vf1_ip(12, [17,2], 6, 27,21)
        , "f_deltap    2 15+4  2 16+8\n"
        , iy()
        , groove_2(2)
        ]),),

    'uni0E20':    #PHO SAMPHAO
        "%s" % ('\n'.join([""
        , hf_pho_samphao(46,18,12, 26,25,8,43,37, 22)
        , hr_ko_kai(47,33,1)
        , ix()
        , dry_2(20)
        #y
        , sy()
        , v0(1)
        , vmu1_ko_kai(30, 25,26,27,8,9,10)
        , vmu2(5)
        , vb0l_head(1, 15,21, 40,34)
        , iy()
        ]),),

    'uni0E21':    #MO MA
        "%s" % ('\n'.join([""
        , hf_mo_ma(53, 9,23, 3, 50,44, 13, 18, 38,32)
        , hr_mo_ma(54, 28,26, 1)
        , ix()
        , dry_2(16)
        , dry_2(11)
        #y
        , sy()
        , vb0(1,26)
        , vr1(28)
        , vf_no_nu(21,15, 35,29)
        , vb0l_mo_ma(1,6,12, 24,47,3,41)
        , iy()
        ]),),

    'uni0E22':    #YO YAK
        "%s" % ('\n'.join([""
        , hf_yo_yak(51, 1,28,5, 14,23, 48,42, 8,19)
        , hr_yo_yak(52,35,33)
        , ix()
        , dry_1(16)
        #y
        , sy()
        , vb0(0,30)
        , vr1(35)
        , vf_no_nu(11,17, 45,39)
        , vadd_yo_yak(17,0, 24, 23, 5)
        , iy()
        ]),),

    'uni0E23':    #RO RUA
        "%s" % ('\n'.join([""
        , hf_ro_rua(51,11,33)
        , hr_ro_rua(52,36,7, 3, 48,42, 23)
        , ix()
        , dry_2(5)
        #y
        , sy()
        , v0(51)
        , vmu1(15)
        , vmu2(30)
        , vb0l_head(51,0,6, 45,39)
        , add_ip(15,6, [9,11,12,33,35])
        , "\nf_deltap 9 12+4\n"
        , sx_notch_1(35)
        , iy()
        , sx_notch_1(12)
        , sx_notch_2(23)
        ]),),

    'uni0E24':    #RU
        "%s" % ('\n'.join([""
        , hf_tho_thung(46,22,26, 12, 25,8, 17, 43,37)
        , hr_ko_kai(47,33, 1)
        , ix()
        , dry_1(15)
        #y
        , sy()
        , vl0_ru(46,1)
        , vmu1_ko_kai(30, 25,26,27,8,9,10)
        , vmu2(5)
        , vb0l_head(46,20,14, 40,34)
        , iy()
        , sx_notch_1(27)
        ]),),

    'uni0E25':    #LO LING
        "%s" % ('\n'.join([""
        , hf_lo_ling(51,17,7, 31, 12, 48,42)
        , hr_mo_ma(52,38,24, 1)
        , ix()
        , dry_1(10)
        , sx_notch_1(23)
        #y
        , sy()
        , v0(1)
        , vmu1_ip(35, [21,24])
        , vmu2(28)
        , vb0l_head(1,15,9, 45,39)
        , vadd_lo_ling(21,4)
        , iy()
        , sx_notch_1(32)
        , groove_1(24)
        ]),),

    'uni0E26':    #LU
        "%s" % ('\n'.join([""
        , hf_pho_samphao(46,18,12, 26,25,8,43,37, 22)
        , hr_ko_kai(47,33,1)
        , ix()
        , dry_2(20)
        #y
        , sy()
        , vl0_ru(46,1)
        , vmu1_ko_kai(30, 25,26,27,8,9,10)
        , vmu2(5)
        , vb0l_head(46, 15,21, 40,34)
        , iy()
        ]),),

    'uni0E27':    #WO WAEN
        "%s" % ('\n'.join([""
        , hf_wo_waen(36,14)
        , hr_ngo_ngu(37,21,7, 3, 33,27)
        , ix()
        , dry_2(5)
        #y
        , sy()
        , v0(36)
        , vmu1(18)
        , vmu2(11)
        , vb0l_head(36,0,6, 30,24)
        , iy()
        , sx_notch_1(15)
        ]),),

    'uni0E28':    #SO SALA
        "%s" % ('\n'.join([""
        , hf_kho_khwai(63,38,14, 35,34,31, 17, 20,26, 60,54)
        , hr_kho_khwai(64,50,1)
        , ix()
        , h_dry_head_12(22,24,28)
        , sx_notch_2(9)
        , sx_notch_1(48)
        #y
        , sy()
        , vs0(1,34)
        , vmu1_ip(41, [17])
        , vmu2(11)
        , vmh_kho_khwai(23,29, 57,51)
        , iy()
        , groove_1(17)
        , sx_notch_2(4)
        , sx_notch_1(43)
        ]),),

    'uni0E29':    #SO RUSI
        "%s" % ('\n'.join([""
        #t += hf_bo_baimai(70,8, 13, 55,49, 3, 1)
        , hf_so_rusi(70,8, 13, 55,49, 3, 1, 24,30, 67,61)
        , hr_so_rusi(71, 36,42,40, 18,34)
        , ix()
        , h_dry_head_2(8)
        , h_dry_head_2(24)
        , h_dry_head_1(30)
        #y
        , sy()
        , vb0s(0,15, 3)
        , vr1(36)
        , vf_no_nu(11,5, 52,46)
        , vadd_so_rusi(21,27, 64,58,34,19,37,42)
        , sx_notch_1(58)
        , iy()
        ]),),

    'uni0E2A':    #SU SUA
        "%s" % ('\n'.join([""
        , hf_lo_ling(63,17,7, 37, 12, 60,54)
        , hr_mo_ma(64,50,24, 1)
        , ix()
        , dry_1(10)
        , sx_notch_1(23)
        , sx_notch_2(32)
        , sx_notch_1(48)
        #y
        , sy()
        , v0(1)
        , vmu1_ip(41, [21,24])
        , vmu2(34)
        , vb0l_head(1,15,9, 57,51)
        , vadd_lo_ling(21,4)
        , iy()
        , sx_notch_1(38)
        , sx_notch_1(43)
        , sx_notch_2(27)
        , groove_1(24)
        ]),),

    'uni0E2B':    #HO HIP
        "%s" % ('\n'.join([""
        , hf_tho_thahan(61,13, 18,7, 46,40, 8)
        , hr_ho_hip(62,36,1, 31,25, 58,52,22,34)
        , hadd_tho_thahan(18,1, 6, 20)
        , ix()
        , dry_2(11)
        #y
        , sy()
        , vs0(1,7)
        , vfr_ho_hip(16,28, 10, 43,37,55,49,22,34, 4)
        , groove_2(4)
        , iy()
        , groove_1(19)
        ]),),

    'uni0E2C':    #LO CHULA
        "%s" % ('\n'.join([""
        , hf_pho_phan(59,9, 14,3, 44,38, 4)
        , hr_lo_chula(60,34,18,1, 30, 22, 56,50,27)
        , add_ip(14,18, [16,17,2])
        , ix()
        , dry_2(7)
        , dry_2(20)
        #y
        , sy()
        , vbs1s(1,3, 18,15)
        , vfr_lo_chula(12,6, 41,35, 25,19, 53,47,27,32)
        , "\nf_deltap    2 15+4  2 16+8\n"
        , add_ip(19,1, [17,2])
        , iy()
        , groove_2(2)
        , sx_notch_1(27)
        ]),),

    'uni0E2D':    #O ANG
        "%s" % ('\n'.join([""
        , hf_o_ang(46,1,11, 23, 7, 43,37)
        , hr_o_ang(47,30,16)
        , ix()
        , h_dry_head_1(7)
        #y
        , sy()
        , vb0(0,13)
        , vmu1(27)
        , vmu2(20)
        , vmh_o_ang(4,10, 40,34)
        , iy()
        ]),),

    'uni0E2E':    #HO NOKHUK
        "%s" % ('\n'.join([""
        , hf_ho_nokhuk(58,1,11, 24,56, 7, 47,41)
        , hr_ho_nokhuk(59,34,16, 52,29,32,19)
        , ix()
        , dry_1(5)
        , dry_1(9)
        , dry_1(20)
        , sx_notch_2(52)
        , sx_notch_1(32)
        #y
        , sy()
        , vb0(0,13)
        , vmu1(27)
        , vmh_ho_nokhuk(4,10, 44,38)
        , add_ip(27,4, [54,50,21,29,52,32,19])
        , sx_notch_2(54)
        , sx_notch_1(50)
        , iy()
        , sx_notch_2(29)
        , sx_notch_1(19)
        ]),),

    'uni0E2F':    #PAIYANNOI
        "%s" % ('\n'.join([""
        , hf_kho_khai(36,8, 14, 33,27,17)
        , hr_mo_ma(37,23,1, 22)
        , ix()
        , dry_1(16)
        , sx_notch_1(17)
        #y
        , sy()
        , v0(1)
        , vmu1(11)
        , vadd_paiyan_noi(22, 23,2, 19, 30,24, 5)
        , iy()
        , groove_2(2)
        ]),),

    'uni0E30':    #SARA_A
        "%s" % ('\n'.join([""
        , hf_sara_a(58, 3,32, 9,38, 26,20,55,49, 15,44)
        , ix()
        , h_dry_head_12(34,36,40)
        #y
        , sy()
        , v0(58)
        , vm_sara_a(0,11, 6,23,17, 35,29, 52,46, 40)
        , iy()
        ]),),

    'uni0E31':    #MAI HAN-AKAT
        "%s" % ('\n'.join([""
        , hr_mai_hanakat(9,8, 26,20, 15)
        , ix()
        , h_dry_head_12(5,7,11)
        #y
        , sy()
        , vm_mai_hanakat(0,11, 6,23,17)
        , iy()
        ]),),

    'uni0E32':    #SARA AA
        "%s" % ('\n'.join([""
        , hf_wo_waen(16,8)
        , hr_ko_kai(17,15,1)
        , ix()
        #y
        , sy()
        , v0(1)
        , vmu1(12)
        , vmu2(5)
        , iy()
        , sx_notch_1(9)
        ]),),

    'uni0E34':    #SARA I
        "%s" % ('\n'.join([""
        , hr_sara_i(0,3, 17,11)
        , ix()
        #y
        , sy()
        , vm_sara_i(2,18,14,7)
        , iy()
        ]),),

    'uni0E35':    #SARA II
        "%s" % ('\n'.join([""
        , hr_sara_ii(0,3, 18,12, 10)
        , ix()
        , groove_2(12)
        #y
        , sy()
        , vm_sara_ii(2,19,15,7, 9, 10)
        , iy()
        , sx_notch_1(9)
        ]),),

    'uni0E36':    #SARA UE
        "%s" % ('\n'.join([""
        , hr_sara_ue(0,3, 27,21, 15,9,33,39)
        , ix()
        , groove_2(21)
        , sx_notch_1(18)
        #y
        , sy()
        , vm_sara_ue(2,28,24,7, 9, 12,18, 36,30)
        , iy()
        , sx_notch_1(9)
        ]),),

    'uni0E37':    #SARA UEE
        "%s" % ('\n'.join([""
        , hr_sara_uee(0,3, 23,17, 15,12,10)
        , ix()
        , groove_2(17)
        #y
        , sy()
        , vm_sara_uee(2,24,20,7, 14,9, 10,15)
        , iy()
        , sx_notch_1(9)
        , sx_notch_1(14)
        ]),),

    'uni0E38':    #SARA U
        "%s" % ('\n'.join([""
        , hr_sara_u(13,1, 7, 23,17)
        , ix()
        , h_dry_head_2(7)
        #y
        , sy()
        , vr_sara_u(26, 10,4, 20,14, 1)
        , iy()
        ]),),

    'uni0E39':    #SARA UU
        "%s" % ('\n'.join([""
        , hr_sara_uu(17,15,13,1, 7, 27,21,)
        , ix()
        , h_dry_head_2(7)
        #y
        , sy()
        , vr_sara_uu(32, 10,16, 4, 24,18, 14, 1)
        , iy()
        ]),),

    'uni0E3A':    #PHINTHU
        "%s" % ('\n'.join([""
        , hr_phinthu(9,3)
        , ix()
        #y
        , sy()
        , vr_phinthu(12,6,0)
        , iy()
        ]),),

    'uni0E3F':    #BAHT
        "%s" % ('\n'.join([""
        , hf_baht(43,3, 23,34, 21,32,5,1, 31,20,42,7, 28,17, 39,11)
        , ix()
        #y
        , sy()
        , vm_baht(2,20, 1, 21,25, 5,8, 6, 33,42, 32,36, 22,31, 14) 
        , iy()
        ]),),

    'uni0E40':    #SARA E
        "%s" % ('\n'.join([""
        , hr_sara_e(25, 9,2, 21,15, 4)
        , ix()
        , dry_1(7)
        #y
        , sy()
        , v0(24)
        , vr1(4)
        , vb0l_head(24,0,6, 18,12)
        , iy()
        ]),),

    'uni0E42':    #SARA O
        "%s" % ('\n'.join([""
        , hf_ro_rua(51,6,28)
        , hr_sara_e(52,36,2, 48,42, 31)
        , ix()
        , dry_1(34)
        #y
        , sy()
        , v0(51)
        , vm_sara_o(10,25)
        , vb0l_head(51,0,33,45,39)
        , iy()
        , sx_notch_1(7)
        ]),),

    'uni0E43':    #SARA AI MAIMUAN
        "%s" % ('\n'.join([""
        , hf_sara_ai_maimuan(65,22,16, 62,56, 8,28)
        , hr_sara_e(66,38,2, 50,44, 33)
        , ix()
        , dry_1(36)
        , dry_1(14)
        , groove_1(13)
        #y
        , sy()
        , v0(65)
        , vm_sara_ai_maimuan(25,11,13, 19, 59,53, 65, 4,32)
        , vb0l_head(65,0,35,47,41)
        , iy()
        ]),),

    'uni0E44':    #SARA AI MAIMALAI
        "%s" % ('\n'.join([""
        , hr_sara_e(39, 23,2, 35,29, 18)
        , hadd_sara_ai_maimalai(10, 14,7,6)
        , ix()
        , dry_1(21)
        #y
        , sy()
        , v0(38)
        , vm_sara_ai_maimalai(17,3, 11, 6,14)
        , vb0l_head(38,0,20, 32,26)
        , iy()
        ]),),

    'uni0E45':    #LAKHANGYAO
        "%s" % ('\n'.join([""
        , hf_wo_waen(16,8)
        , hr10(17,15,1,g1="gap_195")
        , ix()
        #y
        , sy()
        , v0(16)
        , vmu1(12)
        , vmu2(5)
        , vl0_ru(16,1)
        , iy()
        , sx_notch_1(9)
        ]),),

    'uni0E46':    #LAKHANGYAO
        "%s" % ('\n'.join([""
        , hf_maiyamok(39,18,12, 36,38,9)
        , hr10(40,26,1,g1="gap_186")
        , add_ip(9,1, [21,22,23,4,5,6,7])
        , ix()
        , h_dry_head_1(12)
        #y
        , sy()
        , v0(39)
        , vmu1s(23,21)
        , vmu2s(4,7)
        , vm3(5,22)
        , vmh_do_dek(9,15, 33,27)
        , vl0_ru(39,1)
        , iy()
        ]),),

    'uni0E47':    #MAITAIKHU
        "%s" % ('\n'.join([""
        , hr_maitaikhu(42,36, 54,48, 11,26)
        , ix()
        , h_dry_head_1(42)
        #y
        , sy()
        , vm_maitaikhu(0,8, 31, 28,36,5, 39, 51,45, 22,15)
        , iy()
        ]),),

    'uni0E48':    #MAI EK
        "%s" % ('\n'.join([""
        , hr_mai_ek(0,2)
        , ix()
        #y
        , sy()
        , vm_mai_ek(0,3)
        , iy()
        ]),),

    'uni0E49':    #MAI THO
        "%s" % ('\n'.join([""
        , hr_mai_tho(20, 8,2,14,32,26)
        , ix()
        , groove_2(5)
        , h_dry_head_2(8)
        , h_dry_head_1(14)
        #y
        , sy()
        , vm_mai_tho(0,3, 11,29,23)
        , iy()
        ]),),

    'uni0E4A':    #MAI TRI
        "%s" % ('\n'.join([""
        , hr_mai_tri(26,3,12,18,44,38)
        , ix()
        , groove_1(9)
        , groove_1(28)
        , groove_2(29)
        , h_dry_head_1(12)
        #y
        , sy()
        , vm_mai_tri(15,0, 28, 9, 41,35, 21,23,7,5)
        , iy()
        , groove_1(22)
        ]),),

    'uni0E4B':    #MAI CHATTAWA
        "%s" % ('\n'.join([""
        , hr_mai_chattawa(11,8,2,5)
        , ix()
        , sx_notch_2(5)
        #y
        , sy()
        , vm_mai_chattawa(0,11,2,8,5)
        , iy()
        , sx_notch_1(5)
        ]),),

    'uni0E4C':    #THANTHAKHAT
        "%s" % ('\n'.join([""
        , hr_thanthakhat(17,3, 29,23)
        , ix()
        , h_dry_head_2(3)
        , h_dry_head_1(17)
        #y
        , sy()
        , vm_thanthakhat(0,7, 26,20, 15)
        , iy()
        ]),),

    'uni0E4D':    #NIKKHAHIT
        "%s" % ('\n'.join([""
        , v0(9)
        , head0(3, 21,15)
        , ix()
        #y
        , sy()
        , v0(0)
        , head0(6, 18,12)
        , iy()
        ]),),

    'uni0E4E':    #YAMAKKAN
        "%s" % ('\n'.join([""
        , hr_yamakkan(16,30, 26,0, 4, 7, 21,10)
        , ix()
        , sx_notch_2(7)
        #y
        , sy()
        , vm_yamakkan(0,34,26,25, 7, 18,13)
        , iy()
        ]),),

    'uni0E4F':    #FONGMAN
        "%s" % ('\n'.join([""
        , hv_fongman(5,29,35,53,47,41,23,15)
        , ix()
        #y
        , sy()
        , hv_fongman(0,20,32,44,50,38,26,10)
        , iy()
        ]),),

    }

#    elif chr == 'uni0E50':    #THAI DIGIT ZERO
#        , hfn0(4,25)
#        add1 = "\nf_deltap 12 9+8  12 11-8  12 16-8"  
#        , hfn0(12,19,add1)
#        , ix()
#        #y
#        , sy()
#        , v0(28)
#        , vmu1n(8)
#        , vmu2n(22)
#        , vb0(0,16)
#        , iy()
#
#    elif chr == 'uni0E51':    #THAI DIGIT ONE
#        add1 = "\nf_deltap 3 9-8  3 10-8  "
#        , hfn0(3,22,add1)
#        add1 = "\nf_deltap 9 11+8  "
#        , hfn0(9,16,add1)
#        , hadd_one(33,27, 45,39)
#        , ix()
#        #y
#        , sy()
#        , v0(48)
#        , vmu1n(6)
#        , vmu2n(19)
#        , vmh_do_dek(30,0,42,36)
#        , vadd_one(48,13)
#        , iy()
#
#    elif chr == 'uni0E52':    #THAI DIGIT ONE
#        add1 = ""
#        #add1 = "\nf_deltap 3 9-8  3 10-8  "
#        , hfn0(4,11,add1)
#        , hadd_one(32,26, 52,46)
#        add1 = "\nf_deltap 9 10+8  "
#        , hfn0(40,17,add1)
#        , add_ip(32,40, [35,36,37,19,20,21])
#        , ix()
#        #y
#        , sy()
#        , vb0(0,14)
#        , vmu1ns(37,35)
#        , vmu2ns(19,21)
#        , vmh_do_dek(23,29,49,43)
#        , iy()



#++++++++++++++++++++++++++++++

if __name__ == "__main__":
    x = sys.argv
    if '--all' in x:    #find&replace in sfd file
        #$0 --all = ENCODE ALL CHARS
        sfd_file = os.path.basename(sys.argv[0]).split('.',1)[0] + '.sfd'
        print "Encoding all character in %s" % (sfd_file)
        dfont.inst_encode_all( sfd_file, pseudo_code_dict, cvt_dict )
    elif '-b' in x:   #both pseudo code & instructed code
        x.remove('-b')
        txt = pseudo_code_dict[x[1]]
        gedit(txt,1)
    else:           #instructed code
        txt = pseudo_code_dict[x[1]]
        gedit(txt)
